dnl **********************************************************************
dnl
dnl Copyright (c) 1999
dnl Object Oriented Concepts, Inc.
dnl Billerica, MA, USA
dnl
dnl All Rights Reserved
dnl
dnl **********************************************************************

dnl ----------------------------------------------------------------------
dnl ORBacus-specific configuration
dnl ----------------------------------------------------------------------

AC_SUBST(OB_CPPFLAGS)
AC_SUBST(OB_LDFLAGS)
AC_SUBST(OB_IDLFLAGS)
AC_SUBST(OB_LIBS)
AC_SUBST(OB_LIBVER)
AC_SUBST(IDL)

OB_CPPFLAGS=
OB_LDFLAGS=
OB_IDLFLAGS=
OB_LIBS=
OB_LIBVER=
IDL=

dnl
dnl Discover the ORBacus path.
dnl
ob_path=

if test -z "$ob_path" -a -n "$with_ob" -a "$with_ob" != "yes"
then
    if test "$with_ob" = "no"
    then
	AC_MSG_ERROR(ORBacus required!)
    fi

    dnl
    dnl Search in the directory specified by the --with-ob option
    dnl
    ob_path="${with_ob}/"
    if test ! -f ${ob_path}include/OB/CORBA.h
    then
	ob_path="${ob_path}ob/"
	if test ! -f ${ob_path}include/OB/CORBA.h
	then
	    ob_path=
	fi
    fi
fi

if test -z "$ob_path"
then
    dnl
    dnl Search in the current directory or ../ob
    dnl	
    ob_path="./"
    if test ! -f ${ob_path}include/OB/CORBA.h
    then
	ob_path="../ob/"
	if test ! -f ${ob_path}include/OB/CORBA.h
	then
	    ob_path=
	fi
    fi
fi

if test -z "$ob_path" -a -n "$prefix"
then
    dnl
    dnl Search in the installation directory
    dnl
    ob_path="${prefix}/"
    if test ! -f ${ob_path}include/OB/CORBA.h
    then
	ob_path="${ob_path}ob/"
	if test ! -f ${ob_path}include/OB/CORBA.h
	then
	    ob_path=
	fi
    fi	
fi

dnl
dnl Error message if we didn't find the ORBacus path.
dnl
if test ! -f ${ob_path}include/OB/CORBA.h
then
    AC_MSG_ERROR(Can't find ORBacus! Use the --with-ob=DIR option.)
fi

dnl
dnl ORBacus shared library versioning
dnl
ob_ver=""
if test "$LIBEXT" != ".a"
then
    ob_ver=`grep '#define OB_VERSION' \
 	< ${ob_path}include/OB/Basic.h | sed -e 's/^.* \"//' -e 's/\"$//'`
    OB_LIBVER=".${ob_ver}"
fi

dnl
dnl Add $(top_srcdir) to relative paths (current directory and ../ob)
dnl
if test "$ob_path" = "./"
then
    ob_path="\$(top_srcdir)/"
fi

if test "$ob_path" = "../ob/"
then
    ob_path="\$(top_srcdir)/../ob/"
fi

OB_LDFLAGS="$OB_LDFLAGS -L${ob_path}lib"
OB_CPPFLAGS="$OB_CPPFLAGS -I${ob_path}include"
OB_IDLFLAGS="$OB_IDLFLAGS -I${ob_path}idl"
OB_LIBS="$OB_LIBS -lOB"
IDL="${ob_path}bin/idl"

#
# Check that the JThreads/C++ package is installed and set the 
# appropriate compiler flags and variables.
#
builtin(include,../config/jtc.m4)

dnl
dnl Add JTC path and library to the OB variables.
dnl
if test "$jtc_path" != "$ob_path"
then
    OB_LDFLAGS="$OB_LDFLAGS $JTC_LDFLAGS"
    OB_CPPFLAGS="$OB_CPPFLAGS $JTC_CPPFLAGS"
fi
OB_LIBS="$OB_LIBS $JTC_LIBS"
