#!/bin/sh
# **********************************************************************
#
# Copyright (c) 1999
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

#
# Delete old log files
#
delete_logfiles()
{
    type=$1

    rm -f "$type"_colloc.log
    rm -f "$type"_client.log
    rm -f "$type"_server.log
}

#
# Function to run the test executables.
#
execute_test()
{
    #
    # The type of test being preformed
    #
    type=$1

    #
    # Set name of reference file
    #
    ref=$2

    #
    # Run remote tests
    #
    $echo
    $echo "Running remote tests:"

    #
    # Start server
    #
    $echo
    $echo "Waiting for server to start up... \c"
    rm -f $ref
    ( $server & echo $! > srvid ) 2>&1 | tee -a "$type"_server.log &
    count=0
    while test ! -s $ref -a $count -lt 8
    do
	sleep 1
	count=`expr $count + 1`
    done
    if test ! -s $ref
    then
	$echo "Failed!"
	$echo "(Server was not started)"
	exit
    else
	$echo "OK!"
    fi

    #
    # Start client
    #
    $client 2>&1 | tee -a "$type"_client.log

    #
    # Wait for server deactivation
    #
    $echo "Waiting for server to deactivate... \c"
    count=0
    while test -r $ref -a $count -lt 3
    do
	sleep 1
	count=`expr $count + 1`
    done

    if test -r $ref
    then
	$echo "Failed!"
	$echo "(Server was not deactivated by client - deactivating server now)"
	deactivate
    else
	$echo "OK!"
    fi
}


#
# Function to run the collocated test executables.
#
execute_colloc_test()
{
    type=$1

    #
    # Run collocated tests
    #
    $echo
    $echo "Running collocated tests:"
    $echo
    $colloc 2>&1 | tee -a "$type"_colloc.log
}
