// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OBE/CORBA.h>

#include <Hello_impl.h>

// ----------------------------------------------------------------------
// Hello_impl constructor
// ----------------------------------------------------------------------

Hello_impl::Hello_impl(CORBA::ORB_ptr orb,
                       PortableServer::POA_ptr poa)
    : orb_(CORBA::ORB::_duplicate(orb)),
      poa_(PortableServer::POA::_duplicate(poa))
{
}

// ----------------------------------------------------------------------
// Hello_impl public member implementation
// ----------------------------------------------------------------------

void
Hello_impl::say_hello()
    throw(CORBA::SystemException)
{
    puts("Hello World!");
}

void
Hello_impl::shutdown()
    throw(CORBA::SystemException)
{
    orb_ -> shutdown(false);
}

PortableServer::POA_ptr
Hello_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(poa_);
}
