// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef __OBE_OBORB_fwd_h__
#define __OBE_OBORB_fwd_h__

#include <OBE/Template.h>

namespace CORBA
{

class ORB;
typedef ORB* ORB_ptr;
typedef ORB* ORBRef;

} // End of namespace CORBA

namespace OB
{

class Logger;
typedef Logger* Logger_ptr;
typedef Logger* LoggerRef;

} // End of namespace OB

namespace OBCORBA
{

class ORB;
typedef ORB* ORB_ptr;
typedef ORB* ORBRef;

} // End of namespace OBCORBA

void OBDuplicate(CORBA::ORB_ptr);
void OBRelease(CORBA::ORB_ptr);

void OBMarshal(CORBA::ORB_ptr, OB::OutputStreamImpl*);
void OBUnmarshal(CORBA::ORB_ptr&, OB::InputStreamImpl*);

void OBDuplicate(OB::Logger_ptr);
void OBRelease(OB::Logger_ptr);

void OBMarshal(OB::Logger_ptr, OB::OutputStreamImpl*);
void OBUnmarshal(OB::Logger_ptr&, OB::InputStreamImpl*);

void OBDuplicate(OBCORBA::ORB_ptr);
void OBRelease(OBCORBA::ORB_ptr);

void OBMarshal(OBCORBA::ORB_ptr, OB::OutputStreamImpl*);
void OBUnmarshal(OBCORBA::ORB_ptr&, OB::InputStreamImpl*);

namespace CORBA
{

typedef OB::ObjVar< ORB > ORB_var;
typedef OB::ObjOut< ORB > ORB_out;

} // End of namespace CORBA

namespace OB
{

typedef OB::ObjVar< Logger > Logger_var;
typedef OB::ObjOut< Logger > Logger_out;

} // End of namespace OB

namespace OBCORBA
{

typedef OB::ObjVar< ORB > ORB_var;
typedef OB::ObjOut< ORB > ORB_out;

} // End of namespace OBCORBA

#endif
