// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OBE_OBPOAMANAGER_H
#define OBE_OBPOAMANAGER_H

#ifndef OBE_IMPORT
#   ifdef OB_DLL
#      define OBE_IMPORT __declspec(dllimport)
#   else
#      define OBE_IMPORT /**/
#   endif
#endif

#include <OBE/OBPOAManager_fwd.h>
#include <OBE/POAManager.h>

namespace OBPortableServer
{

//
// Implementation of PortableServer::POAManager
//
class POAManager : public PortableServer::POAManager
{
    POAManager(const POAManager&);
    void operator=(const POAManager&);

    static OBE_IMPORT const char* ids_[];

public:

    POAManager(OB::ORBInstance_ptr)
	throw(CORBA::SystemException);
    ~POAManager();

    typedef POAManager_ptr _ptr_type;
    typedef POAManager_var _var_type;

    static inline POAManager_ptr
    _duplicate(POAManager_ptr p)
    {
        if(p)
            p -> _OB_incRef();
        return p;
    }

    static inline POAManager_ptr
    _nil()
    {
        return 0;
    }

    static POAManager_ptr _narrow(CORBA::Object_ptr);

    static const char** _OB_staticIds();

    virtual bool _OB_isLC() const { return true; };

    //
    // Standard IDL to C++ Mapping
    //
    
    //
    // Mapping for OBPortableServer::POAManager
    //
    OCI::AcceptorSeq*
    get_acceptors()
	throw(CORBA::SystemException);
};

} // End of namespace OBPortableServer

namespace CORBA
{

inline void
release(OBPortableServer::POAManager_ptr p)
{
    if(p)
        p -> _OB_decRef();
}

inline Boolean
is_nil(OBPortableServer::POAManager_ptr p)
{
    return p == 0;
}

} // End of namespace CORBA

#endif
