// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_ORB_INIT_H
#define OB_ORB_INIT_H

#include <OBE/OBORB_fwd.h>
#include <OBE/Properties_fwd.h>
#include <OBE/Logger_fwd.h>

namespace CORBA
{

//
// ORB initialization
//
ORB_ptr ORB_init(int&, char**, const char* = "", const char* = OBE_VERSION);

typedef char* ORBid;

} // End of namespace CORBA

namespace OBCORBA
{

//
// Proprietary ORBacus ORB_init calls
//
OBCORBA::ORB_ptr
ORB_init(int&, char**, OB::Properties_ptr, OB::Logger_ptr,
	 const char* = "", const char* = OBE_VERSION);

OBCORBA::ORB_ptr
ORB_init(int&, char**, OB::Properties_ptr, const char* = "",
	 const char* = OBE_VERSION);

} // End of namespace OBCORBA

namespace OB
{

//
// Consume command line arguments and populate the given property set
//
void
ParseArgs(int&, char**, Properties_ptr, Logger_ptr = 0);

} // End of namespace OB

#endif
