// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_LOGGER_IMPL_H
#define OB_LOGGER_IMPL_H

#include <OBE/Object.h>
#include <OBE/Logger.h>

namespace OB
{

//
// The logger implementation class
//
class Logger_impl : public Logger, public JTCMutex
{
    //
    // Hide copy-constructor and assignment operator
    //
    Logger_impl(const Logger_impl&);
    void operator=(const Logger_impl&);

    virtual void message(const char*);

public:

    Logger_impl();
    virtual ~Logger_impl();

    //
    // IDL to C++ mapping
    //
    virtual void info(const char*);
    virtual void error(const char*);
    virtual void warning(const char*);
    virtual void trace(const char*, const char*);
};

} // End of namespace OB

#endif
