# **********************************************************************
#
# Copyright (c) 2000
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

SERVERLIB_NAME	= $(top_srcdir)\lib\OBEServer$(LIBSUFFIX).lib
CLIENTLIB_NAME	= $(top_srcdir)\lib\OBEClient$(LIBSUFFIX).lib

PDB_NAME	= $(top_srcdir)\lib\OBE.pdb

#
# Work around the inference rules problem with nmake.
#

PDB_FLAGS       = /Fd$(PDB_NAME)
TARGETS         = $(CLIENTLIB_NAME) \
		  $(SERVERLIB_NAME)

!include $(top_srcdir)\config\Make.rules.mak

HDIR		= $(top_srcdir)\include\OBE

COMMON_OBJS	= Basic.obj \
		  Hashtable.obj \
		  CompletionStatus.obj \
		  Except.obj \
		  Any.obj \
		  TCKind.obj \
		  TypeCode.obj \
		  Principal.obj \
		  RefCounted.obj \
		  IOP.obj \
		  Object.obj \
		  MarshalStubImpl.obj \
		  Policy.obj \
		  OBPolicies.obj \
		  OBPolicies_impl.obj \
		  ORBPolicyManager_impl.obj \
		  Types.obj \
		  ORBInstance.obj \
		  InitialServiceManager.obj \
		  ORBControl.obj \
		  OBORB.obj \
		  OBORBAny.obj \
		  ORB_init.obj \
		  Client.obj \
		  GIOPClient.obj \
		  GIOPClientWorker.obj \
		  Downcall.obj \
		  IIOP.obj \
		  CoreTraceLevels.obj \
		  OCIBuffer.obj \
		  OCITypes.obj \
		  OCIClient.obj \
		  OCIClient_impl.obj \
		  OCIClient_IIOP.obj \
		  OCIClient_IIOP_impl.obj \
		  Net.obj \
		  Properties.obj \
		  Logger.obj \
		  Logger_impl.obj \
		  Stream.obj \
		  StreamAny.obj \
		  CorbaURL.obj

CLIENT_OBJS	= ORBControlC.obj \
		  ORBInstanceC.obj \
		  ORBMemberFactoryC.obj

SERVER_OBJS	= ORBControlS.obj \
		  ORBInstanceS.obj \
		  ORBMemberFactoryS.obj \
		  Current.obj \
		  POACommon.obj \
		  POA.obj \
		  PortableServerGlobal.obj \
		  ObjectKey.obj \
		  POAManager.obj \
		  POAOAInterface_impl.obj \
		  POAServantBase.obj \
		  ClientS.obj \
		  CollocatedClient.obj \
		  CollocatedServer.obj \
		  Server.obj \
		  GIOPServer.obj \
		  GIOPServerStarter.obj \
		  GIOPServerWorker.obj \
		  Upcall.obj \
		  ObjectIdHasher.obj \
		  OCI.obj \
		  OCI_impl.obj \
		  OCI_IIOP.obj \
		  OCI_IIOP_impl.obj \
		  IIOPConfig.obj \
		  BootManager.obj


#
# Also in non-DLL mode needed for the clean target
#
SERVERLIB_DEF_NAME = OBEServer$(LIBSUFFIX).def
SERVERLIB_DLL_NAME = $(top_srcdir)\lib\OBEServer$(OBE_LIBVER)$(LIBSUFFIX).dll
SERVERLIB_EXP_NAME = $(top_srcdir)\lib\OBEServer$(LIBSUFFIX).exp

CLIENTLIB_DEF_NAME = OBEClient$(LIBSUFFIX).def
CLIENTLIB_DLL_NAME = $(top_srcdir)\lib\OBEClient$(OBE_LIBVER)$(LIBSUFFIX).dll
CLIENTLIB_EXP_NAME = $(top_srcdir)\lib\OBEClient$(LIBSUFFIX).exp


ALL_IDLFLAGS	= $(OBE_IDLFLAGS) -DOB_CPLUSPLUS --this-header-dir OBE \
		  --dll-import OBE_IMPORT

!if "$(DLL)" == "yes"

ALL_CXXFLAGS	= $(CXXFLAGS)

ALL_DLLLIBS	= $(OBE_DLLLIBS) $(DLLLIBS)
ALL_CPPFLAGS	= /DOBE_BUILD_DLL /I. $(OBE_CPPFLAGS) $(CPPFLAGS)

$(SERVERLIB_NAME): $(SERVERLIB_DLL_NAME)

$(CLIENTLIB_NAME): $(CLIENTLIB_DLL_NAME)

$(SERVERLIB_DEF_NAME):

$(CLIENTLIB_DEF_NAME):

$(SERVERLIB_DLL_NAME): $(SERVER_OBJS) $(COMMON_OBJS) $(SERVERLIB_DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(SERVERLIB_DEF_NAME) \
	OBEServer$(OBE_LIBVER)$(LIBSUFFIX) $(SERVER_OBJS) $(COMMON_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x64000000 /def:$(SERVERLIB_DEF_NAME) \
	/IMPLIB:$(SERVERLIB_NAME) /out:$@ $(SERVER_OBJS) $(COMMON_OBJS) \
	$(ALL_DLLLIBS)

$(CLIENTLIB_DLL_NAME): $(CLIENT_OBJS) $(COMMON_OBJS) $(CLIENTLIB_DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(CLIENTLIB_DEF_NAME) \
	OBEClient$(OBE_LIBVER)$(LIBSUFFIX) $(CLIENT_OBJS) $(COMMON_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x65000000 /def:$(CLIENTLIB_DEF_NAME) \
	/IMPLIB:$(CLIENTLIB_NAME) /out:$@ $(CLIENT_OBJS) $(COMMON_OBJS) \
	$(ALL_DLLLIBS)

!else

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)
ALL_CPPFLAGS	= /I. $(OBE_CPPFLAGS) $(CPPFLAGS)

$(SERVERLIB_NAME): $(SERVER_OBJS) $(COMMON_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(SERVER_OBJS) $(COMMON_OBJS)

$(CLIENTLIB_NAME): $(CLIENT_OBJS) $(COMMON_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(CLIENT_OBJS) $(COMMON_OBJS)

!endif

$(top_srcdir)\include\OBE\WinConfig.h: $(top_srcdir)\..\config\WinConfig.h
	copy $(top_srcdir)\..\config\WinConfig.h $@

$(top_srcdir)\include\OBE\Config.h: $(top_srcdir)\include\OBE\WinConfig.h \
				   $(top_srcdir)\..\config\Make.rules.mak
	if exist $@ del $@
!if "$(DLL)" == "yes"
	echo #define OBE_DLL 1 >> $@
!else
	echo /* #undef OBE_DLL */ >> $@
!endif
!if "$(OLD_IOSTREAM)" != "yes"
	echo #define HAVE_IOSTREAM 1 >> $@
!else
	echo /* #undef HAVE_IOSTREAM */ >> $@
!endif
!if "$(WITH_OBE_NO_TRACE)" == "yes"
	echo #define HAVE_OBE_NO_TRACE 1 >> $@
!else
	echo /* #undef HAVE_OBE_NO_TRACE */ >> $@
!endif
!if "$(WITH_OBE_NO_COLLOC)" == "yes"
	echo #define HAVE_OBE_NO_COLLOC 1 >> $@
!else
	echo /* #undef HAVE_OBE_NO_COLLOC */ >> $@
!endif
	echo #include "WinConfig.h" >> $@

clean::
	-del $(top_srcdir)\include\OBE\Config.h

all:: $(HDIR)\orb.h
$(HDIR)/orb.h: \
		$(IDLDIR)/OBE/orb.idl
	-@del orb.cpp
	-@del $(HDIR)\orb.h
	$(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	$(IDLDIR)\OBE\orb.idl
	move orb.h $(HDIR)
	-@del orb.cpp

CompletionStatus.cpp $(HDIR)/CompletionStatus.h: \
		$(IDLDIR)/OBE/CompletionStatus.idl
	-@del CompletionStatus.cpp
	-@del $(HDIR)\CompletionStatus.h
	$(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	$(IDLDIR)\OBE\CompletionStatus.idl
	move CompletionStatus.h $(HDIR)

TCKind.cpp $(HDIR)/TCKind.h: $(IDLDIR)/OBE/TCKind.idl
	-@del TCKind.cpp
	-@del $(HDIR)\TCKind.h
	$(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	$(IDLDIR)\OBE\TCKind.idl
	move TCKind.h $(HDIR)

Types.cpp $(HDIR)/Types.h: \
		$(IDLDIR)/OBE/Types.idl
	-@del Types.cpp
	-@del $(HDIR)\Types.h
	-@del Types_skel.cpp
	-@del $(HDIR)\Types_skel.h
	$(IDL) $(ALL_IDLFLAGS) $(IDLDIR)\OBE\Types.idl
	move Types.h $(HDIR)
	move Types_skel.h $(HDIR)
	-@del Types_skel.cpp

Logger.cpp $(HDIR)/Logger.h $(HDIR)/Logger_fwd.h: \
		$(IDLDIR)/OBE/Logger.idl
	-@del Logger.cpp
	-@del $(HDIR)\Logger_fwd.h
	-@del $(HDIR)\Logger.h
	$(IDL) $(ALL_IDLFLAGS) --fwd \
	--locality-constrained --no-virtual-inheritance \
	$(IDLDIR)\OBE\Logger.idl
	move Logger_fwd.h $(HDIR)
	move Logger.h $(HDIR)

IOP.cpp $(HDIR)/IOP.h: \
		$(IDLDIR)/OBE/IOP.idl
	-@del IOP.cpp
	-@del $(HDIR)\IOP.h
	-@del IOP_skel.cpp
	-@del $(HDIR)\IOP_skel.h
	$(IDL) $(ALL_IDLFLAGS) --no-type-codes \
	$(IDLDIR)\OBE\IOP.idl
	move IOP.h $(HDIR)
	move IOP_skel.h $(HDIR)
	-@del IOP_skel.cpp

IIOP.cpp $(HDIR)/IIOP.h: \
		$(IDLDIR)/OBE/IIOP.idl
	-@del IIOP.cpp
	-@del $(HDIR)\IIOP.h
	$(IDL) $(ALL_IDLFLAGS) --no-type-codes \
	$(IDLDIR)\OBE\IIOP.idl
	move IIOP.h $(HDIR)

Current.cpp $(HDIR)/Current.h $(HDIR)/Current_fwd.h: \
		$(IDLDIR)/OBE/Current.idl
	-@del Current.cpp
	-@del $(HDIR)\Current_fwd.h
	-@del $(HDIR)\Current.h
	$(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	$(IDLDIR)\OBE\Current.idl
	move Current_fwd.h $(HDIR)
	move Current.h $(HDIR)

Policy.cpp $(HDIR)/Policy.h $(HDIR)/Policy_fwd.h: \
		$(IDLDIR)/OBE/Policy.idl
	-@del Policy.cpp
	-@del $(HDIR)\Policy_fwd.h
	-@del $(HDIR)\Policy.h
	$(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	--no-virtual-inheritance $(IDLDIR)\OBE\Policy.idl
	move Policy_fwd.h $(HDIR)
	move Policy.h $(HDIR)

OBPolicies.cpp $(HDIR)/OBPolicies.h $(HDIR)/OBPolicies_fwd.h: \
		$(IDLDIR)/OBE/OBPolicies.idl
	-@del OBPolicies.cpp
	-@del $(HDIR)\OBPolicies_fwd.h
	-@del $(HDIR)\OBPolicies.h
	$(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	--no-virtual-inheritance $(IDLDIR)\OBE\OBPolicies.idl
	move OBPolicies_fwd.h $(HDIR)
	move OBPolicies.h $(HDIR)

POACommon.cpp $(HDIR)/POACommon.h $(HDIR)/POACommon_fwd.h: \
		$(IDLDIR)/OBE/POACommon.idl
	-@del POACommon.cpp
	-@del $(HDIR)\POACommon_fwd.h
	-@del $(HDIR)\POACommon.h
	-@del POACommon_skel.cpp
	-@del $(HDIR)\POACommon_skel.h
	$(IDL) $(ALL_IDLFLAGS) --fwd \
	--no-type-codes $(IDLDIR)\OBE\POACommon.idl
	move POACommon_fwd.h $(HDIR)
	move POACommon.h $(HDIR)
	move POACommon_skel.h $(HDIR)
	-@del POACommon_skel.cpp

OCITypes.cpp $(HDIR)/OCITypes.h: \
		$(IDLDIR)/OBE/OCITypes.idl
	-@del OCITypes.cpp
	-@del $(HDIR)\OCITypes.h
	$(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	--no-type-codes $(IDLDIR)\OBE\OCITypes.idl
	move OCITypes.h $(HDIR)

OCI.cpp $(HDIR)/OCI.h $(HDIR)/OCI_fwd.h: \
		$(IDLDIR)/OBE/OCI.idl
	-@del OCI.cpp
	-@del $(HDIR)\OCI_fwd.h
	-@del $(HDIR)\OCI.h
	$(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	--no-virtual-inheritance $(IDLDIR)\OBE\OCI.idl
	move OCI_fwd.h $(HDIR)
	move OCI.h $(HDIR)

OCIClient.cpp $(HDIR)/OCIClient.h $(HDIR)/OCIClient_fwd.h: \
		$(IDLDIR)/OBE/OCIClient.idl
	--@del OCIClient.cpp
	--@del $(HDIR)\OCIClient_fwd.h
	--@del $(HDIR)\OCIClient.h
	$(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	--no-virtual-inheritance $(IDLDIR)\OBE\OCIClient.idl
	move OCIClient_fwd.h $(HDIR)
	move OCIClient.h $(HDIR)

OCI_IIOP.cpp $(HDIR)/OCI_IIOP.h $(HDIR)/OCI_IIOP_fwd.h: \
		$(IDLDIR)/OBE/OCI_IIOP.idl
	-@del OCI_IIOP.cpp
	-@del $(HDIR)\OCI_IIOP_fwd.h
	-@del $(HDIR)\OCI_IIOP.h
	$(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	--no-virtual-inheritance $(IDLDIR)\OBE\OCI_IIOP.idl
	move OCI_IIOP_fwd.h $(HDIR)
	move OCI_IIOP.h $(HDIR)

OCIClient_IIOP.cpp $(HDIR)/OCIClient_IIOP.h $(HDIR)/OCIClient_IIOP_fwd.h: \
		$(IDLDIR)/OBE/OCIClient_IIOP.idl
	-@del OCIClient_IIOP.cpp
	-@del $(HDIR)\OCIClient_IIOP_fwd.h
	-@del $(HDIR)\OCIClient_IIOP.h
	$(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	--no-virtual-inheritance $(IDLDIR)\OBE\OCIClient_IIOP.idl
	move OCIClient_IIOP_fwd.h $(HDIR)
	move OCIClient_IIOP.h $(HDIR)

#
# Work around the inference rules problem with nmake.
#

install:: all
	copy $(SERVERLIB_NAME) $(libdir)
	copy $(CLIENTLIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)

!if "$(DLL)" == "yes"

SERVERLIB_DLL_PDB = $(SERVERLIB_DLL_NAME:.dll=.pdb)
CLIENTLIB_DLL_PDB = $(CLIENTLIB_DLL_NAME:.dll=.pdb)

install:: all
	copy $(SERVERLIB_DLL_NAME) $(libdir)
	copy $(CLIENTLIB_DLL_NAME) $(libdir)
	copy $(SERVERLIB_EXP_NAME) $(libdir)
	copy $(CLIENTLIB_EXP_NAME) $(libdir)
	if exist $(SERVERLIB_DLL_PDB) copy $(SERVERLIB_DLL_PDB) $(libdir)
	if exist $(CLIENTLIB_DLL_PDB) copy $(CLIENTLIB_DLL_PDB) $(libdir)

clean::
	if exist $(SERVERLIB_DLL_PDB) del $(SERVERLIB_DLL_PDB)
	if exist $(CLIENTLIB_DLL_PDB) del $(CLIENTLIB_DLL_PDB)

!endif

clean::
	-del $(PDB_NAME) $(SERVERLIB_DLL_NAME) $(SERVERLIB_EXP_NAME) \
	$(SERVERLIB_DEF_NAME) $(SERVERLIB_PDB_NAME) $(CLIENTLIB_DLL_NAME) \
	$(CLIENTLIB_EXP_NAME) $(CLIENTLIB_DEF_NAME) $(CLIENTLIB_PDB_NAME)

min:: all

install_min:: install

!include .windep
