// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_OCI_IMPL_H
#define OB_OCI_IMPL_H

#include <OBE/Object.h>
#include <OBE/Except.h>
#include <OBE/OCI.h>
#include <OBE/Defs.h>

#include <OCIClient_impl.h>

namespace OB
{

class ORBInstanceS; // For the friend declaration

} // End of namespace OB

namespace OCI
{

//
// The AccFactoryRegistry_impl class
//
class AccFactoryRegistry_impl :
	virtual public AccFactoryRegistry, public JTCMutex
{
    //
    // All acceptor factories
    //
    AccFactory_var factories_[MAX_ACC_FACTORY];
    CORBA::ULong factoryCount_;

    //
    // Hide copy-constructor and assignment operator
    //
    AccFactoryRegistry_impl(const AccFactoryRegistry_impl&);
    void operator=(const AccFactoryRegistry_impl&);

    AccFactoryRegistry_impl() : factoryCount_(0) { }
    virtual ~AccFactoryRegistry_impl() { }

    // ORBInstanceS creates AccFactoryRegistry_impl
    friend class ::OB::ORBInstanceS;

public:

    //
    // Standard IDL to C++ Mapping
    //
    virtual void add_factory(AccFactory_ptr)
        throw(FactoryAlreadyExists,
              CORBA::SystemException);

    virtual AccFactory_ptr get_factory(OCI::ProtocolId)
        throw(NoSuchFactory,
              CORBA::SystemException);

    virtual AccFactorySeq* get_factories()
        throw(CORBA::SystemException);
};

} // End of namespace OCI

#endif
