// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OBE/ORBControl.h>
#include <OBE/ORBInstance.h>
#include <OBE/InitialServiceManager.h>
#include <OBE/Properties.h>
#include <OBE/Logger.h>

using namespace OB;
using namespace CORBA;

// ----------------------------------------------------------------------
// External, non-inline duplicate/release for templates
// ----------------------------------------------------------------------

void
OBDuplicate(OB::ORBControl_ptr p)
{
    if(p)
        p -> _OB_incRef();
}

void
OBRelease(OB::ORBControl_ptr p)
{
    if(p)
        p -> _OB_decRef();
}

// ----------------------------------------------------------------------
// ORBControl constructor and destructor
// ----------------------------------------------------------------------

ORBControl::ORBControl(ORBInstance_ptr instance)
    : orbInstance_(ORBInstance::_duplicate(instance)),
      state_(StateNotRunning),
      shutdown_(false)
{
}

ORBControl::~ORBControl()
{
}

// ----------------------------------------------------------------------
// ORBControl public member implementation
// ----------------------------------------------------------------------

void
ORBControl::destroy()
    throw(SystemException)
{
    JTCSynchronized synchronized(*this);

    //
    // destroy() may not be called unless the client side has been
    // shutdown
    //
    assert(state_ == StateClientShutdown);
    state_ = StateDestroyed;

    //
    // Set the ORBInstance object to nil
    //
    orbInstance_ = ORBInstance::_nil();
}
