// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef ORB_CONTROL_S_H
#define ORB_CONTROL_S_H

#include <OBE/ORBControl_fwd.h>
#include <OBE/ORBInstance_fwd.h>

namespace OB
{

//
// The ORBControlS class -- ORBControl for server apps
//
class ORBControlS : public ORBControl
{
    //
    // Monitor used to notify threads waiting for server shutdown
    //
    JTCMonitor monitor_;

    //
    // Complete shutdown of the ORB, if necessary. Return true if the
    // shutdown is complete.
    //
    virtual void completeServerShutdown()
	throw();

    //
    // Validate the state
    //
    virtual void validateState()
	throw(CORBA::SystemException);

    //
    // Are we inside a method invocation?
    //
    virtual bool insideMethodInvocation()
	throw();

    virtual void blockServerShutdownComplete()
	throw();

public:

    ORBControlS(ORBInstance_ptr);
    ~ORBControlS();

    //
    // Initialize the root POA
    //
    virtual void initializeRootPOA();

    //
    // Run the ORB event loop
    //
    virtual void run()
	throw(CORBA::SystemException);

    //
    // Shutdown the server side of the ORB
    //
    virtual void shutdownServer(bool)
	throw(CORBA::SystemException);

    //
    // Shutdown the server (if necessary) & client side of the ORB
    //
    virtual void shutdownServerClient()
        throw(CORBA::SystemException);
};

} // End of namespace OB

#endif
