// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef ORB_INSTANCE_C_H
#define ORB_INSTANCE_C_H

#include <OBE/ORBInstance_fwd.h>

namespace OB
{
    
//
// The ORBInstanceC class. This class implements the ORBInstance
// abstract class and provides items needed by client applications.
//
class ORBInstanceC : public ORBInstance
{
    //
    // Hide copy-constructor and assignment operator
    //
    ORBInstanceC(const ORBInstanceC&);
    void operator=(const ORBInstanceC&);

    //
    // Initialize and destroy hooks used by derived classes
    // (called by initialize() and destroy() respectively)
    //
    virtual void initializeHook() { }
    virtual void destroyHook() { }

    //
    // Create the ClientManager
    //
    virtual ClientManager_ptr createClientManager(ORBInstance_ptr);

public:

    ORBInstanceC() { }
    ~ORBInstanceC() { }
};

} // End of namespace OB

#endif
