// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_POA_OA_INTERFACE_IMPL_H
#define OB_POA_OA_INTERFACE_IMPL_H

#include <OBE/OAInterface.h>

#include <OBE/ORBInstance_fwd.h>
#include <OBE/BootManager_fwd.h>
#include <OBE/POAManager_fwd.h>
#include <OBE/BootManager_fwd.h>

namespace OB
{

//
// We don't need any sort of concurrency protection on this class
// since its lifecycle is tightly coupled with the POAManager. Once
// the POAManager destroys this class it should not be possible for
// any further requests to arrive (or any requests in the process of
// being dispatched).
//
class POAOAInterface_impl : public OAInterface
{
    //
    // The ORBInstance
    //
    ORBInstance_var orbInstance_;

    //
    // The POAManager implementation
    //
    PortableServer::POAManager_ptr poaManager_;

    //
    // The boot manager and implementation
    //
    BootManager_var bootManager_;

public:

    POAOAInterface_impl(PortableServer::POAManager_ptr,
			ORBInstance_ptr);

    virtual bool setupUpcall(UpcallImpl*)
	throw();

    virtual LocateStatus findByKey(const OCI::ObjectKey&, RefCountIOR_out)
	throw();

    virtual OCI::ProfileInfoSeq* getUsableProfiles(const OCI::IOR&,
						   const CORBA::PolicyList&)
	throw();

    virtual void activate()
	throw();
};

} // End namespace OB

#endif
