// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OBE/Basic.h>
#include <OBE/Except.h>
#include <OBE/POAServantBase.h>

using namespace CORBA;
using namespace OB;

// ----------------------------------------------------------------------
// PortableServer namespace functions
// ----------------------------------------------------------------------

char*
PortableServer::ObjectId_to_string(const ObjectId& id)
{
    //
    // IF we have any '\0' characters in the id then throw a BAD_PARAM
    // exception
    //
    if(::memchr(id.get_buffer(), 0, id.length()) != 0)
        throw BAD_PARAM();
    
    String_var str = string_alloc(id.length());
    memcpy(str.inout(), id.get_buffer(), id.length());
    str[id.length()] = '\0';
    return str._retn();
}

PortableServer::ObjectId*
PortableServer::string_to_ObjectId(const char* str)
{
    size_t len = ::strlen(str);
    ObjectId_var oid = new ObjectId(len);
    oid -> length(len);
    memcpy(oid -> get_buffer(), str, len);
    return oid._retn();
}
