// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OBE/CORBA.h>

using namespace CORBA;

int
main(int argc, char* argv[], char*[])
{
    int status = EXIT_SUCCESS;
    ORB_var orb;

    try
    {
        orb = ORB_init(argc, argv);

        int ServerRun(ORB_ptr, bool, int, char*[]);
        status = ServerRun(orb, true, argc, argv);

        if(status == 0)
        {
            int ClientRun(ORB_ptr, bool, int, char*[]);
            status = ClientRun(orb, true, argc, argv);

	    //
	    // Shutdown the ORB
	    //
	    orb -> shutdown(true);

	    //
	    // Cleanup
	    //
	    extern void ServerCleanup();
	    ServerCleanup();
        }
    }
    catch(const Exception& ex)
    {
	fprintf(stderr, "%s\n", ex._rep_id());
        status = EXIT_FAILURE;
    }

    if(!is_nil(orb))
    {
	try
	{
	    orb -> destroy();
	}
	catch(const Exception& ex)
	{
	    fprintf(stderr, "%s\n", ex._rep_id());
	    status = EXIT_FAILURE;
	}
    }

    return status;
}
