# **********************************************************************
#
# Copyright (c) 2000
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

SERVER_NAME	= server.exe
COLLOCATED_NAME	= collocated.exe
CLIENT_NAME	= client.exe

TARGETS 	= $(SERVER_NAME) \
		  $(COLLOCATED_NAME) \
		  $(CLIENT_NAME)

!include $(top_srcdir)\config\Make.rules.mak

CMN_OBJS	= TestIntf.obj \
		  TestIntf_2_3_NoLongDouble.obj \
		  TestIntf_2_3.obj

SRVR_OBJS	= TestIntf_skel.obj \
		  TestIntf_2_3_NoLongDouble_skel.obj \
		  TestIntf_2_3_skel.obj \
		  Test_impl.obj \
		  Server.obj

CLNT_OBJS	= TestStub.obj \
		  TestStubException.obj \
		  TestStubTimeout.obj \
		  Client.obj

SERVER_OBJS	= ServerMain.obj

COLLOCATED_OBJS	= CollocatedMain.obj

CLIENT_OBJS	= ClientMain.obj

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /I. /I..\include $(OBE_CPPFLAGS) $(CPPFLAGS)
SERVER_LIBS	= $(OBE_SERVER_LIBS) $(LIBS)
CLIENT_LIBS	= $(OBE_CLIENT_LIBS) $(LIBS)

$(SERVER_NAME): $(SERVER_OBJS) $(CMN_OBJS) $(SRVR_OBJS)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ \
	$(SERVER_OBJS) $(CMN_OBJS) $(SRVR_OBJS) $(SERVER_LIBS)

$(COLLOCATED_NAME): $(COLLOCATED_OBJS) $(CMN_OBJS) $(SRVR_OBJS) $(CLNT_OBJS)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ \
	$(COLLOCATED_OBJS) $(CMN_OBJS) $(SRVR_OBJS) $(CLNT_OBJS) $(SERVER_LIBS)

$(CLIENT_NAME): $(CLIENT_OBJS) $(CMN_OBJS) $(CLNT_OBJS)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ \
	$(CLIENT_OBJS) $(CMN_OBJS) $(CLNT_OBJS) $(CLIENT_LIBS)

TestIntf.cpp TestIntf.h: TestIntf.idl
	-del TestIntf.cpp TestIntf.h
	$(IDL) --tie TestIntf.idl

TestIntf_skel.cpp TestIntf_skel.h TestIntf_tie.h TestIntf_skel_tie.h: 
	TestIntf.cpp

TestIntf_2_3_NoLongDouble.cpp TestIntf_2_3_NoLongDouble.h: \
	TestIntf_2_3_NoLongDouble.idl
	-del TestIntf_2_3_NoLongDouble.cpp TestIntf_2_3_NoLongDouble.h
	$(IDL) --tie TestIntf_2_3_NoLongDouble.idl

TestIntf_2_3_NoLongDouble_skel.cpp TestIntf_2_3_NoLongDouble_skel.h \
	TestIntf_2_3_NoLongDouble_tie.h TestIntf_2_3_NoLongDouble_skel_tie.h: 
	TestIntf_2_3_NoLongDouble.cpp

TestIntf_2_3.cpp TestIntf_2_3.h: TestIntf_2_3.idl
	-del TestIntf_2_3.cpp TestIntf_2_3.h
	$(IDL) --tie TestIntf_2_3.idl

TestIntf_2_3_skel.cpp TestIntf_2_3_skel.h TestIntf_2_3_tie.h \
	TestIntf_2_3_skel_tie.h: 
	TestIntf_2_3.cpp

!include .windep
