// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OBE/CORBA.h>

#include <Test_impl.h>

#include <limits.h>

#ifdef HAVE_UNISTD_H
#   include <unistd.h>
#endif

using namespace CORBA;

TestIntf_2_3_impl::TestIntf_2_3_impl(ORB_ptr orb)
    : orb_(ORB::_duplicate(orb))
{
}

// ----------------------------------------------------------------------
// Methods from TestIntf
// ----------------------------------------------------------------------

void
TestIntf_2_3_impl::deactivate()
    throw(SystemException)
{
    orb_ -> shutdown(false);
}

ULong
TestIntf_2_3_impl::version()
    throw(SystemException)
{
    return OBE_INTEGER_VERSION;
}

void
TestIntf_2_3_impl::sleepOneway(ULong sec)
    throw(SystemException)
{
#ifdef WIN32
    Sleep(sec * 1000);
#else
    sleep(sec);
#endif
}

void
TestIntf_2_3_impl::sleepTwoway(ULong sec)
    throw(SystemException)
{
#ifdef WIN32
    Sleep(sec * 1000);
#else
    sleep(sec);
#endif
}

void
TestIntf_2_3_impl::opVoid()
    throw(SystemException)
{
}

void
TestIntf_2_3_impl::opVoidEx()
    throw(TestIntf::ExVoid,
	  SystemException)
{
    throw TestIntf::ExVoid();
}

Short
TestIntf_2_3_impl::attrShort()
    throw(SystemException)
{
    return aShort;
}

void
TestIntf_2_3_impl::attrShort(Short val)
    throw(SystemException)
{
    aShort = val;
}

Short
TestIntf_2_3_impl::opShort(Short a0,
			   Short& a1,
			   Short& a2)
    throw(SystemException)
{
    aShort = a0 + a1;
    a1 = a2 = aShort;
    return aShort;
}

Short
TestIntf_2_3_impl::opShortEx(Short a0,
			     Short& a1,
			     Short&)
    throw(TestIntf::ExShort,
	  SystemException)
{
    aShort = a0 + a1;
    throw TestIntf::ExShort(aShort);
    return 0; // Some compilers need this
}

Long
TestIntf_2_3_impl::attrLong()
    throw(SystemException)
{
    return aLong;
}

void
TestIntf_2_3_impl::attrLong(Long val)
    throw(SystemException)
{
    aLong = val;
}

Long
TestIntf_2_3_impl::opLong(Long a0,
			  Long& a1,
			  Long& a2)
    throw(SystemException)
{
    aLong = a0 + a1;
    a1 = a2 = aLong;
    return aLong;
}

Long
TestIntf_2_3_impl::opLongEx(Long a0,
			    Long& a1,
			    Long&)
    throw(TestIntf::ExLong,
	  SystemException)
{
    aLong = a0 + a1;
    throw TestIntf::ExLong(aLong);
    return 0; // Some compilers need this
}

UShort
TestIntf_2_3_impl::attrUShort()
    throw(SystemException)
{
    return aUShort;
}

void
TestIntf_2_3_impl::attrUShort(UShort val)
    throw(SystemException)
{
    aUShort = val;
}

UShort
TestIntf_2_3_impl::opUShort(UShort a0,
			    UShort& a1,
			    UShort& a2)
    throw(SystemException)
{
    aUShort = a0 + a1;
    a1 = a2 = aUShort;
    return aUShort;
}

UShort
TestIntf_2_3_impl::opUShortEx(UShort a0,
			    UShort& a1,
			    UShort&)
    throw(TestIntf::ExUShort,
	  SystemException)
{
    aUShort = a0 + a1;
    throw TestIntf::ExUShort(aUShort);
    return 0; // Some compilers need this
}

ULong
TestIntf_2_3_impl::attrULong()
    throw(SystemException)
{
    return aULong;
}

void
TestIntf_2_3_impl::attrULong(ULong val)
    throw(SystemException)
{
    aULong = val;
}

ULong
TestIntf_2_3_impl::opULong(ULong a0,
			   ULong& a1,
			   ULong& a2)
    throw(SystemException)
{
    aULong = a0 + a1;
    a1 = a2 = aULong;
    return aULong;
}

ULong
TestIntf_2_3_impl::opULongEx(ULong a0,
			   ULong& a1,
			   ULong&)
    throw(TestIntf::ExULong,
	  SystemException)
{
    aULong = a0 + a1;
    throw TestIntf::ExULong(aULong);
    return 0; // Some compilers need this
}

Float
TestIntf_2_3_impl::attrFloat()
    throw(SystemException)
{
    return aFloat;
}

void
TestIntf_2_3_impl::attrFloat(Float val)
    throw(SystemException)
{
    aFloat = val;
}

Float
TestIntf_2_3_impl::opFloat(Float a0,
			   Float& a1,
			   Float& a2)
    throw(SystemException)
{
    aFloat = a0 + a1;
    a1 = a2 = aFloat;
    return aFloat;
}

Float
TestIntf_2_3_impl::opFloatEx(Float a0,
			   Float& a1,
			   Float&)
    throw(TestIntf::ExFloat,
	  SystemException)
{
    aFloat = a0 + a1;
    throw TestIntf::ExFloat(aFloat);
    return 0; // Some compilers need this
}

Double
TestIntf_2_3_impl::attrDouble()
    throw(SystemException)
{
    return aDouble;
}

void
TestIntf_2_3_impl::attrDouble(Double val)
    throw(SystemException)
{
    aDouble = val;
}

Double
TestIntf_2_3_impl::opDouble(Double a0,
			    Double& a1,
			    Double& a2)
    throw(SystemException)
{
    aDouble = a0 + a1;
    a1 = a2 = aDouble;
    return aDouble;
}

Double
TestIntf_2_3_impl::opDoubleEx(Double a0,
			    Double& a1,
			    Double&)
    throw(TestIntf::ExDouble,
	  SystemException)
{
    aDouble = a0 + a1;
    throw TestIntf::ExDouble(aDouble);
    return 0; // Some compilers need this
}

Boolean
TestIntf_2_3_impl::attrBoolean()
    throw(SystemException)
{
    return aBoolean;
}

void
TestIntf_2_3_impl::attrBoolean(Boolean val)
    throw(SystemException)
{
    aBoolean = val;
}

Boolean
TestIntf_2_3_impl::opBoolean(Boolean a0,
			     Boolean& a1,
			     Boolean& a2)
    throw(SystemException)
{
    aBoolean = a0 && a1;
    a1 = a2 = aBoolean;
    return aBoolean;
}

Boolean
TestIntf_2_3_impl::opBooleanEx(Boolean a0,
			     Boolean& a1,
			     Boolean&)
    throw(TestIntf::ExBoolean,
	  SystemException)
{
    aBoolean = a0 && a1;
    throw TestIntf::ExBoolean(aBoolean);
    return 0; // Some compilers need this
}

Char
TestIntf_2_3_impl::attrChar()
    throw(SystemException)
{
    return aChar;
}

void
TestIntf_2_3_impl::attrChar(Char val)
    throw(SystemException)
{
    aChar = val;
}

Char
TestIntf_2_3_impl::opChar(Char a0,
			  Char& a1,
			  Char& a2)
    throw(SystemException)
{
    aChar = a0 + a1;
    a1 = a2 = aChar;
    return aChar;
}

Char
TestIntf_2_3_impl::opCharEx(Char a0,
			  Char& a1,
			  Char&)
    throw(TestIntf::ExChar,
	  SystemException)
{
    aChar = a0 + a1;
    throw TestIntf::ExChar(aChar);
    return 0; // Some compilers need this
}

Octet
TestIntf_2_3_impl::attrOctet()
    throw(SystemException)
{
    return aOctet;
}

void
TestIntf_2_3_impl::attrOctet(Octet val)
    throw(SystemException)
{
    aOctet = val;
}

Octet
TestIntf_2_3_impl::opOctet(Octet a0,
			   Octet& a1,
			   Octet& a2)
    throw(SystemException)
{
    aOctet = a0 + a1;
    a1 = a2 = aOctet;
    return aOctet;
}

Octet
TestIntf_2_3_impl::opOctetEx(Octet a0,
			   Octet& a1,
			   Octet&)
    throw(TestIntf::ExOctet,
	  SystemException)
{
    aOctet = a0 + a1;
    throw TestIntf::ExOctet(aOctet);
    return 0; // Some compilers need this
}

char*
TestIntf_2_3_impl::attrString()
    throw(SystemException)
{
    return string_dup(aString);
}

void
TestIntf_2_3_impl::attrString(const char* val)
    throw(SystemException)
{
    aString = val;
}

char*
TestIntf_2_3_impl::opString(const char* a0,
			    char*& a1,
			    String_out a2)
    throw(SystemException)
{
    aString = string_alloc(strlen(a0) + strlen(a1));
    strcpy(aString.inout(), a0);
    strcat(aString.inout(), a1);
    string_free(a1);
    a1 = string_dup(aString);
    a2 = string_dup(aString);
    return string_dup(aString);
}

char*
TestIntf_2_3_impl::opStringEx(const char* a0,
			    char*& a1,
			    String_out)
    throw(TestIntf::ExString,
	  SystemException)
{
    aString = string_alloc(strlen(a0) + strlen(a1));
    strcpy(aString.inout(), a0);
    strcat(aString.inout(), a1);
    throw TestIntf::ExString(aString);
    return 0; // Some compilers need this
}

Any*
TestIntf_2_3_impl::attrAny()
    throw(SystemException)
{
    return new Any(aAny);
}

void
TestIntf_2_3_impl::attrAny(const Any& val)
    throw(SystemException)
{
    aAny = val;
}

Any*
TestIntf_2_3_impl::opAny(const Any& a0,
			 Any& a1,
			 Any_out a2)
    throw(SystemException)
{
    aAny = a0;
    a1 = aAny;
    a2 = new Any(aAny);
    return new Any(aAny);
}

Any*
TestIntf_2_3_impl::opAnyEx(const Any& a0,
			 Any&,
			 Any_out)
    throw(TestIntf::ExAny,
	  SystemException)
{
    aAny = a0;
    throw TestIntf::ExAny(aAny);
    return 0; // Some compilers need this
}

TestIntf::TestEnum
TestIntf_2_3_impl::attrTestEnum()
    throw(SystemException)
{
    return aTestEnum;
}

void
TestIntf_2_3_impl::attrTestEnum(TestIntf::TestEnum val)
    throw(SystemException)
{
    aTestEnum = val;
}

TestIntf::TestEnum
TestIntf_2_3_impl::opTestEnum(TestIntf::TestEnum a0,
			      TestIntf::TestEnum& a1,
			      TestIntf::TestEnum& a2)
    throw(SystemException)
{
    aTestEnum = a0;
    a1 = a2 = aTestEnum;
    return aTestEnum;
}

TestIntf::TestEnum
TestIntf_2_3_impl::opTestEnumEx(TestIntf::TestEnum a0,
			      TestIntf::TestEnum&,
			      TestIntf::TestEnum&)
    throw(TestIntf::ExTestEnum,
	  SystemException)
{
    aTestEnum = a0;
    throw TestIntf::ExTestEnum(aTestEnum);
    return TestIntf::TestEnum1; // Some compilers need this
}

TestIntf_ptr
TestIntf_2_3_impl::attrTestIntf()
    throw(SystemException)
{
    return TestIntf::_duplicate(aTestIntf);
}

void
TestIntf_2_3_impl::attrTestIntf(TestIntf_ptr val)
    throw(SystemException)
{
    aTestIntf = TestIntf::_duplicate(val);
}

TestIntf_ptr
TestIntf_2_3_impl::opTestIntf(TestIntf_ptr a0,
			      TestIntf_ptr& a1,
			      TestIntf_out a2)
    throw(SystemException)
{
    aTestIntf = TestIntf::_duplicate(a0);
    release(a1);
    a1 = TestIntf::_duplicate(aTestIntf);
    a2 = TestIntf::_duplicate(aTestIntf);
    return TestIntf::_duplicate(aTestIntf);
}

TestIntf_ptr
TestIntf_2_3_impl::opTestIntfEx(TestIntf_ptr a0,
				TestIntf_ptr&,
				TestIntf_out)
    throw(TestIntf::ExTestIntf,
	  SystemException)
{
    aTestIntf = TestIntf::_duplicate(a0);
    throw TestIntf::ExTestIntf(aTestIntf);
    return TestIntf::_nil(); // Some compilers need this
}

TestIntf::FixedStruct
TestIntf_2_3_impl::attrFixedStruct()
    throw(SystemException)
{
    return aFixedStruct;
}

void
TestIntf_2_3_impl::attrFixedStruct(const TestIntf::FixedStruct& val)
    throw(SystemException)
{
    aFixedStruct = val;
}

TestIntf::FixedStruct
TestIntf_2_3_impl::opFixedStruct(const TestIntf::FixedStruct& a0,
				 TestIntf::FixedStruct& a1,
				 TestIntf::FixedStruct& a2)
    throw(SystemException)
{
    aFixedStruct = a0;
    a1 = a2 = aFixedStruct;
    return aFixedStruct;
}

TestIntf::FixedStruct
TestIntf_2_3_impl::opFixedStructEx(const TestIntf::FixedStruct& a0,
				 TestIntf::FixedStruct&,
				 TestIntf::FixedStruct&)
    throw(TestIntf::ExFixedStruct,
	  SystemException)
{
    aFixedStruct = a0;
    throw TestIntf::ExFixedStruct(aFixedStruct);
    return TestIntf::FixedStruct(); // Some compilers need this
}

TestIntf::VariableStruct*
TestIntf_2_3_impl::attrVariableStruct()
    throw(SystemException)
{
    return new TestIntf::VariableStruct(aVariableStruct);
}

void
TestIntf_2_3_impl::attrVariableStruct(const TestIntf::VariableStruct&
				       val)
    throw(SystemException)
{
    aVariableStruct = val;
}

TestIntf::VariableStruct*
TestIntf_2_3_impl::opVariableStruct(const TestIntf::VariableStruct& a0,
				    TestIntf::VariableStruct& a1,
				    TestIntf::VariableStruct_out a2)
    throw(SystemException)
{
    aVariableStruct = a0;
    a1 = aVariableStruct;
    a2 = new TestIntf::VariableStruct(aVariableStruct);
    return new TestIntf::VariableStruct(aVariableStruct);
}

TestIntf::VariableStruct*
TestIntf_2_3_impl::opVariableStructEx(const TestIntf::VariableStruct&
				    a0,
				    TestIntf::VariableStruct&,
				    TestIntf::VariableStruct_out)
    throw(TestIntf::ExVariableStruct,
	  SystemException)
{
    aVariableStruct = a0;
    throw TestIntf::ExVariableStruct(aVariableStruct);
    return new TestIntf::VariableStruct; // Some compilers need this
}

TestIntf::FixedUnion
TestIntf_2_3_impl::attrFixedUnion()
    throw(SystemException)
{
    return aFixedUnion;
}

void
TestIntf_2_3_impl::attrFixedUnion(const TestIntf::FixedUnion& val)
    throw(SystemException)
{
    aFixedUnion = val;
}

TestIntf::FixedUnion
TestIntf_2_3_impl::opFixedUnion(const TestIntf::FixedUnion& a0,
				TestIntf::FixedUnion& a1,
				TestIntf::FixedUnion& a2)
    throw(SystemException)
{
#if defined(__GNUC__) && defined(__OPTIMIZE__) // COMPILERFIX
    volatile int dummy = 1;
    dummy++;
#endif

    aFixedUnion = a0;
    a1 = a2 = aFixedUnion;
    return aFixedUnion;
}

TestIntf::FixedUnion
TestIntf_2_3_impl::opFixedUnionEx(const TestIntf::FixedUnion& a0,
				TestIntf::FixedUnion&,
				TestIntf::FixedUnion&)
    throw(TestIntf::ExFixedUnion,
	  SystemException)
{
    aFixedUnion = a0;
    throw TestIntf::ExFixedUnion(aFixedUnion);
    return TestIntf::FixedUnion(); // Some compilers need this
}

TestIntf::VariableUnion*
TestIntf_2_3_impl::attrVariableUnion()
    throw(SystemException)
{
    return new TestIntf::VariableUnion(aVariableUnion);
}

void
TestIntf_2_3_impl::attrVariableUnion(const TestIntf::VariableUnion& val)
    throw(SystemException)
{
    aVariableUnion = val;
}

TestIntf::VariableUnion*
TestIntf_2_3_impl::opVariableUnion(const TestIntf::VariableUnion& a0,
				   TestIntf::VariableUnion& a1,
				   TestIntf::VariableUnion_out a2)
    throw(SystemException)
{
    aVariableUnion = a0;
    a1 = aVariableUnion;
    a2 = new TestIntf::VariableUnion(aVariableUnion);
    return new TestIntf::VariableUnion(aVariableUnion);
}

TestIntf::VariableUnion*
TestIntf_2_3_impl::opVariableUnionEx(const TestIntf::VariableUnion& a0,
				   TestIntf::VariableUnion&,
				   TestIntf::VariableUnion_out)
    throw(TestIntf::ExVariableUnion,
	  SystemException)
{
    aVariableUnion = a0;
    throw TestIntf::ExVariableUnion(aVariableUnion);
    return new TestIntf::VariableUnion; // Some compilers need this
}

TestIntf::StringSequence*
TestIntf_2_3_impl::attrStringSequence()
    throw(SystemException)
{
    return new TestIntf::StringSequence(aStringSequence);
}

void
TestIntf_2_3_impl::attrStringSequence(const TestIntf::StringSequence& val)
    throw(SystemException)
{
    aStringSequence = val;
}

TestIntf::StringSequence*
TestIntf_2_3_impl::opStringSequence(const TestIntf::StringSequence& a0,
				    TestIntf::StringSequence& a1,
				    TestIntf::StringSequence_out a2)
    throw(SystemException)
{
    aStringSequence = a0;
    aStringSequence.length(a0.length() + a1.length());
    for(ULong i = 0 ; i < a1.length() ; i++)
	aStringSequence[a0.length() + i] = a1[i];

    a1 = aStringSequence;
    a2 = new TestIntf::StringSequence(aStringSequence);
    return new TestIntf::StringSequence(aStringSequence);
}

TestIntf::StringSequence*
TestIntf_2_3_impl::
opStringSequenceEx(const TestIntf::StringSequence& a0,
		   TestIntf::StringSequence& a1,
		   TestIntf::StringSequence_out)
    throw(TestIntf::ExStringSequence,
	  SystemException)
{
    aStringSequence = a0;
    aStringSequence.length(a0.length() + a1.length());
    for(ULong i = 0 ; i < a1.length() ; i++)
	aStringSequence[a0.length() + i] = a1[i];

    throw TestIntf::ExStringSequence(aStringSequence);
    return new TestIntf::StringSequence; // Some compilers need this
}

TestIntf::FixedArray_slice*
TestIntf_2_3_impl::attrFixedArray()
    throw(SystemException)
{
    return TestIntf::FixedArray_dup(aFixedArray);
}

void
TestIntf_2_3_impl::attrFixedArray(const TestIntf::FixedArray val)
    throw(SystemException)
{
    TestIntf::FixedArray_copy(aFixedArray, val);
}

TestIntf::FixedArray_slice*
TestIntf_2_3_impl::opFixedArray(const TestIntf::FixedArray a0,
				TestIntf::FixedArray a1,
				TestIntf::FixedArray a2)
    throw(SystemException)
{
    TestIntf::FixedArray_copy(aFixedArray, a0);
    TestIntf::FixedArray_copy(a1, aFixedArray);
    TestIntf::FixedArray_copy(a2, aFixedArray);
    return TestIntf::FixedArray_dup(aFixedArray);
}

TestIntf::FixedArray_slice*
TestIntf_2_3_impl::opFixedArrayEx(const TestIntf::FixedArray a0,
				TestIntf::FixedArray,
				TestIntf::FixedArray)
    throw(TestIntf::ExFixedArray,
	  SystemException)
{
    TestIntf::FixedArray_copy(aFixedArray, a0);
#ifdef HAVE_VCPLUSPLUS_BUGS
    throw TestIntf::ExFixedArray(
	(const TestIntf::FixedArray_slice*)aFixedArray);
#else
    throw TestIntf::ExFixedArray(aFixedArray);
#endif
    return TestIntf::FixedArray_alloc(); // Some compilers need this
}

TestIntf::VariableArray_slice*
TestIntf_2_3_impl::attrVariableArray()
    throw(SystemException)
{
    return TestIntf::VariableArray_dup(aVariableArray);
}

void
TestIntf_2_3_impl::attrVariableArray(const TestIntf::VariableArray val)
    throw(SystemException)
{
    TestIntf::VariableArray_copy(aVariableArray, val);
}

TestIntf::VariableArray_slice*
TestIntf_2_3_impl::opVariableArray(const TestIntf::VariableArray a0,
				   TestIntf::VariableArray a1,
				   TestIntf::VariableArray_out a2)
    throw(SystemException)
{
    TestIntf::VariableArray_copy(aVariableArray, a0);
    TestIntf::VariableArray_copy(a1, aVariableArray);
    a2 = TestIntf::VariableArray_dup(aVariableArray);
    return TestIntf::VariableArray_dup(aVariableArray);
}

TestIntf::VariableArray_slice*
TestIntf_2_3_impl::opVariableArrayEx(const TestIntf::VariableArray a0,
				     TestIntf::VariableArray,
				     TestIntf::VariableArray_out)
    throw(TestIntf::ExVariableArray,
	  SystemException)
{
    TestIntf::VariableArray_copy(aVariableArray, a0);
#ifdef HAVE_VCPLUSPLUS_BUGS
    throw TestIntf::ExVariableArray(
	(const TestIntf::VariableArray_slice*)aVariableArray);
#else
    throw TestIntf::ExVariableArray(aVariableArray);
#endif
    return TestIntf::VariableArray_alloc(); // Some compilers need this
}

TestIntf::FixedArraySequence*
TestIntf_2_3_impl::attrFixedArraySequence()
    throw(SystemException)
{
    return new TestIntf::FixedArraySequence(aFixedArraySequence);
}

void
TestIntf_2_3_impl::
attrFixedArraySequence(const TestIntf::FixedArraySequence& val)
    throw(SystemException)
{
    aFixedArraySequence = val;
}

TestIntf::FixedArraySequence*
TestIntf_2_3_impl::
opFixedArraySequence(const TestIntf::FixedArraySequence& a0,
		     TestIntf::FixedArraySequence& a1,
		     TestIntf::FixedArraySequence_out a2)
    throw(SystemException)
{
    aFixedArraySequence.length(a0.length() + a1.length());
    
    ULong i;
    ULong n = 0;

    for(i = 0 ; i < a0.length() ; i++)
	TestIntf::FixedArray_copy(aFixedArraySequence[n++], a0[i]);
	
    for(i = 0 ; i < a1.length() ; i++)
	TestIntf::FixedArray_copy(aFixedArraySequence[n++], a1[i]);

    a1 = aFixedArraySequence;
    a2 = new TestIntf::FixedArraySequence(aFixedArraySequence);
    return new TestIntf::FixedArraySequence(aFixedArraySequence);
}

TestIntf::FixedArraySequence*
TestIntf_2_3_impl::
opFixedArraySequenceEx(const TestIntf::FixedArraySequence& a0,
		       TestIntf::FixedArraySequence& a1,
		       TestIntf::FixedArraySequence_out)
    throw(TestIntf::ExFixedArraySequence,
	  SystemException)
{
    aFixedArraySequence.length(a0.length() + a1.length());
    
    ULong i;
    ULong n = 0;

    for(i = 0 ; i < a0.length() ; i++)
	TestIntf::FixedArray_copy(aFixedArraySequence[n++], a0[i]);
	
    for(i = 0 ; i < a1.length() ; i++)
	TestIntf::FixedArray_copy(aFixedArraySequence[n++], a1[i]);

    throw TestIntf::ExFixedArraySequence(aFixedArraySequence);
    // Some compilers need this
    return new TestIntf::FixedArraySequence(aFixedArraySequence);
}

TestIntf::VariableArraySequence*
TestIntf_2_3_impl::attrVariableArraySequence()
    throw(SystemException)
{
    return new TestIntf::VariableArraySequence(aVariableArraySequence);
}

void
TestIntf_2_3_impl::
attrVariableArraySequence(const TestIntf::VariableArraySequence& val)
    throw(SystemException)
{
    aVariableArraySequence = val;
}

TestIntf::VariableArraySequence*
TestIntf_2_3_impl::
opVariableArraySequence(const TestIntf::VariableArraySequence& a0,
			TestIntf::VariableArraySequence& a1,
			TestIntf::VariableArraySequence_out a2)
    throw(SystemException)
{
    aVariableArraySequence.length(a0.length() + a1.length());
    
    ULong i;
    ULong n = 0;

    for(i = 0 ; i < a0.length() ; i++)
	TestIntf::VariableArray_copy(aVariableArraySequence[n++], a0[i]);
	
    for(i = 0 ; i < a1.length() ; i++)
	TestIntf::VariableArray_copy(aVariableArraySequence[n++], a1[i]);

    a1 = aVariableArraySequence;
    a2 = new TestIntf::VariableArraySequence(aVariableArraySequence);
    return new TestIntf::VariableArraySequence(aVariableArraySequence);
}

TestIntf::VariableArraySequence*
TestIntf_2_3_impl::
opVariableArraySequenceEx(const TestIntf::VariableArraySequence& a0,
			  TestIntf::VariableArraySequence& a1,
			  TestIntf::VariableArraySequence_out)
    throw(TestIntf::ExVariableArraySequence,
	  SystemException)
{
    aVariableArraySequence.length(a0.length() + a1.length());
    
    ULong i;
    ULong n = 0;

    for(i = 0 ; i < a0.length() ; i++)
	TestIntf::VariableArray_copy(aVariableArraySequence[n++], a0[i]);
	
    for(i = 0 ; i < a1.length() ; i++)
	TestIntf::VariableArray_copy(aVariableArraySequence[n++], a1[i]);

    throw TestIntf::ExVariableArraySequence(aVariableArraySequence);
    // Some compilers need this
    return new TestIntf::VariableArraySequence(aVariableArraySequence);
}

TestIntf::FixedArrayBoundSequence*
TestIntf_2_3_impl::attrFixedArrayBoundSequence()
    throw(SystemException)
{
    return new TestIntf::FixedArrayBoundSequence(aFixedArrayBoundSequence);
}

void
TestIntf_2_3_impl::attrFixedArrayBoundSequence(
    const TestIntf::FixedArrayBoundSequence& val)
    throw(SystemException)
{
    aFixedArrayBoundSequence = val;
}

TestIntf::FixedArrayBoundSequence*
TestIntf_2_3_impl::opFixedArrayBoundSequence(
    const TestIntf::FixedArrayBoundSequence& a0,
    TestIntf::FixedArrayBoundSequence& a1,
    TestIntf::FixedArrayBoundSequence_out a2)
    throw(SystemException)
{
    aFixedArrayBoundSequence.length(a0.length() + a1.length());
    
    ULong i;
    ULong n = 0;

    for(i = 0 ; i < a0.length() ; i++)
	TestIntf::FixedArray_copy(aFixedArrayBoundSequence[n++], a0[i]);
	
    for(i = 0 ; i < a1.length() ; i++)
	TestIntf::FixedArray_copy(aFixedArrayBoundSequence[n++], a1[i]);

    a1 = aFixedArrayBoundSequence;
    a2 = new TestIntf::FixedArrayBoundSequence(aFixedArrayBoundSequence);
    return new TestIntf::FixedArrayBoundSequence(aFixedArrayBoundSequence);
}

TestIntf::FixedArrayBoundSequence*
TestIntf_2_3_impl::opFixedArrayBoundSequenceEx(
    const TestIntf::FixedArrayBoundSequence& a0,
    TestIntf::FixedArrayBoundSequence& a1,
    TestIntf::FixedArrayBoundSequence_out a2)
    throw(TestIntf::ExFixedArrayBoundSequence,
	  SystemException)
{
    aFixedArrayBoundSequence.length(a0.length() + a1.length());
    
    ULong i;
    ULong n = 0;

    for(i = 0 ; i < a0.length() ; i++)
	TestIntf::FixedArray_copy(aFixedArrayBoundSequence[n++], a0[i]);
	
    for(i = 0 ; i < a1.length() ; i++)
	TestIntf::FixedArray_copy(aFixedArrayBoundSequence[n++], a1[i]);

    a1 = aFixedArrayBoundSequence;
    a2 = new TestIntf::FixedArrayBoundSequence(aFixedArrayBoundSequence);

    throw TestIntf::ExFixedArrayBoundSequence(aFixedArrayBoundSequence);
    // Some compilers need this
    return new TestIntf::FixedArrayBoundSequence(aFixedArrayBoundSequence);
}

TestIntf::VariableArrayBoundSequence*
TestIntf_2_3_impl::attrVariableArrayBoundSequence()
    throw(SystemException)
{
    return
	new TestIntf::VariableArrayBoundSequence(aVariableArrayBoundSequence);
}

void
TestIntf_2_3_impl::
attrVariableArrayBoundSequence(
    const TestIntf::VariableArrayBoundSequence& val)
    throw(SystemException)
{
    aVariableArrayBoundSequence = val;
}

TestIntf::VariableArrayBoundSequence*
TestIntf_2_3_impl::opVariableArrayBoundSequence(
    const TestIntf::VariableArrayBoundSequence& a0,
    TestIntf::VariableArrayBoundSequence& a1,
    TestIntf::VariableArrayBoundSequence_out a2)
    throw(SystemException)
{
    aVariableArrayBoundSequence.length(a0.length() + a1.length());
    
    ULong i;
    ULong n = 0;

    for(i = 0 ; i < a0.length() ; i++)
	TestIntf::VariableArray_copy(aVariableArrayBoundSequence[n++], a0[i]);
	
    for(i = 0 ; i < a1.length() ; i++)
	TestIntf::VariableArray_copy(aVariableArrayBoundSequence[n++], a1[i]);

    a1 = aVariableArrayBoundSequence;
    a2 = new TestIntf::VariableArrayBoundSequence(aVariableArrayBoundSequence);
    return
	new TestIntf::VariableArrayBoundSequence(aVariableArrayBoundSequence);
}

TestIntf::VariableArrayBoundSequence*
TestIntf_2_3_impl::opVariableArrayBoundSequenceEx(
    const TestIntf::VariableArrayBoundSequence& a0,
    TestIntf::VariableArrayBoundSequence& a1,
    TestIntf::VariableArrayBoundSequence_out a2)
    throw(TestIntf::ExVariableArrayBoundSequence,
	  SystemException)
{
    aVariableArrayBoundSequence.length(a0.length() + a1.length());
    
    ULong i;
    ULong n = 0;

    for(i = 0 ; i < a0.length() ; i++)
	TestIntf::VariableArray_copy(aVariableArrayBoundSequence[n++], a0[i]);
	
    for(i = 0 ; i < a1.length() ; i++)
	TestIntf::VariableArray_copy(aVariableArrayBoundSequence[n++], a1[i]);

    a1 = aVariableArrayBoundSequence;
    a2 = new TestIntf::VariableArrayBoundSequence(aVariableArrayBoundSequence);
    throw TestIntf::ExVariableArrayBoundSequence(aVariableArrayBoundSequence);
    // Some compilers need this
    return
	new TestIntf::VariableArrayBoundSequence(aVariableArrayBoundSequence);
}

void
TestIntf_2_3_impl::op_UNKNOWN_Ex()
    throw(SystemException)
{
    throw UNKNOWN(1, COMPLETED_YES);
}

void
TestIntf_2_3_impl::op_BAD_PARAM_Ex()
    throw(SystemException)
{
    throw BAD_PARAM(2, COMPLETED_NO);
}

void
TestIntf_2_3_impl::op_NO_MEMORY_Ex()
    throw(SystemException)
{
    throw NO_MEMORY(3, COMPLETED_MAYBE);
}

void
TestIntf_2_3_impl::op_IMP_LIMIT_Ex()
    throw(SystemException)
{
    throw IMP_LIMIT(4, COMPLETED_YES);
}

void
TestIntf_2_3_impl::op_COMM_FAILURE_Ex()
    throw(SystemException)
{
    throw COMM_FAILURE(5, COMPLETED_NO);
}

void
TestIntf_2_3_impl::op_INV_OBJREF_Ex()
    throw(SystemException)
{
    throw INV_OBJREF(6, COMPLETED_MAYBE);
}

void
TestIntf_2_3_impl::op_NO_PERMISSION_Ex()
    throw(SystemException)
{
    throw NO_PERMISSION(7, COMPLETED_YES);
}

void
TestIntf_2_3_impl::op_INTERNAL_Ex()
    throw(SystemException)
{
    throw INTERNAL(8, COMPLETED_NO);
}

void
TestIntf_2_3_impl::op_MARSHAL_Ex()
    throw(SystemException)
{
    throw MARSHAL(9, COMPLETED_MAYBE);
}

void
TestIntf_2_3_impl::op_INITIALIZE_Ex()
    throw(SystemException)
{
    throw INITIALIZE(10, COMPLETED_YES);
}

void
TestIntf_2_3_impl::op_NO_IMPLEMENT_Ex()
    throw(SystemException)
{
    throw NO_IMPLEMENT(11, COMPLETED_NO);
}

void
TestIntf_2_3_impl::op_BAD_TYPECODE_Ex()
    throw(SystemException)
{
    throw BAD_TYPECODE(12, COMPLETED_MAYBE);
}

void
TestIntf_2_3_impl::op_BAD_OPERATION_Ex()
    throw(SystemException)
{
    throw BAD_OPERATION(13, COMPLETED_YES);
}

void
TestIntf_2_3_impl::op_NO_RESOURCES_Ex()
    throw(SystemException)
{
    throw NO_RESOURCES(14, COMPLETED_NO);
}

void
TestIntf_2_3_impl::op_NO_RESPONSE_Ex()
    throw(SystemException)
{
    throw NO_RESPONSE(15, COMPLETED_MAYBE);
}

void
TestIntf_2_3_impl::op_BAD_INV_ORDER_Ex()
    throw(SystemException)
{
    throw BAD_INV_ORDER(17, COMPLETED_NO);
}

void
TestIntf_2_3_impl::op_TRANSIENT_Ex()
    throw(SystemException)
{
    throw TRANSIENT(18, COMPLETED_MAYBE);
}

void
TestIntf_2_3_impl::op_OBJ_ADAPTER_Ex()
    throw(SystemException)
{
    throw OBJ_ADAPTER(24, COMPLETED_MAYBE);
}

void
TestIntf_2_3_impl::op_OBJECT_NOT_EXIST_Ex()
    throw(SystemException)
{
    throw OBJECT_NOT_EXIST(26, COMPLETED_NO);
}

void
TestIntf_2_3_impl::op_INV_POLICY_Ex()
    throw(SystemException)
{
    throw INV_POLICY(30, COMPLETED_NO);
}

// ----------------------------------------------------------------------
// Methods from TestIntf_2_3_NoLongDouble
// ----------------------------------------------------------------------

LongLong
TestIntf_2_3_impl::attrLongLong()
    throw(SystemException)
{
    return aLongLong;
}

void
TestIntf_2_3_impl::attrLongLong(LongLong val)
    throw(SystemException)
{
    aLongLong = val;
}

LongLong
TestIntf_2_3_impl::opLongLong(LongLong a0,
			      LongLong& a1,
			      LongLong& a2)
    throw(SystemException)
{
    aLongLong = a0 + a1;
    a1 = a2 = aLongLong;
    return aLongLong;
}

LongLong
TestIntf_2_3_impl::opLongLongEx(LongLong a0,
				LongLong& a1,
				LongLong&)
    throw(TestIntf_2_3_NoLongDouble::ExLongLong,
	  SystemException)
{
    aLongLong = a0 + a1;
    throw TestIntf_2_3_NoLongDouble::ExLongLong(aLongLong);
    return 0; // Some compilers need this
}

ULongLong
TestIntf_2_3_impl::attrULongLong()
    throw(SystemException)
{
    return aULongLong;
}

void
TestIntf_2_3_impl::attrULongLong(ULongLong val)
    throw(SystemException)
{
    aULongLong = val;
}

ULongLong
TestIntf_2_3_impl::opULongLong(ULongLong a0,
			       ULongLong& a1,
			       ULongLong& a2)
    throw(SystemException)
{
    aULongLong = a0 + a1;
    a1 = a2 = aULongLong;
    return aULongLong;
}

ULongLong
TestIntf_2_3_impl::opULongLongEx(ULongLong a0,
				 ULongLong& a1,
				 ULongLong&)
    throw(TestIntf_2_3_NoLongDouble::ExULongLong,
	  SystemException)
{
    aULongLong = a0 + a1;
    throw TestIntf_2_3_NoLongDouble::ExULongLong(aULongLong);
    return 0; // Some compilers need this
}

// ----------------------------------------------------------------------
// Methods from TestIntf_2_3
// ----------------------------------------------------------------------

LongDouble
TestIntf_2_3_impl::attrLongDouble()
    throw(SystemException)
{
    return aLongDouble;
}

void
TestIntf_2_3_impl::attrLongDouble(LongDouble val)
    throw(SystemException)
{
    aLongDouble = val;
}

LongDouble
TestIntf_2_3_impl::opLongDouble(LongDouble a0,
				LongDouble& a1,
				LongDouble& a2)
    throw(SystemException)
{
#if SIZEOF_LONG_DOUBLE >= 12
    aLongDouble = a0 + a1;
    a1 = a2 = aLongDouble;
#endif
    return aLongDouble;
}

LongDouble
TestIntf_2_3_impl::opLongDoubleEx(LongDouble a0,
				  LongDouble& a1,
				  LongDouble&)
    throw(TestIntf_2_3::ExLongDouble,
	  SystemException)
{
#if SIZEOF_LONG_DOUBLE >= 12
    aLongDouble = a0 + a1;
    throw TestIntf_2_3::ExLongDouble(aLongDouble);
    return 0; // Some compilers need this
#else
    return aLongDouble; // Some compilers need this
#endif
}
