// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef TEST_IMPL_H
#define TEST_IMPL_H

#include <TestIntf_2_3_skel.h>

class TestIntf_2_3_impl
    : public POA_TestIntf_2_3,
      public PortableServer::RefCountServantBase
{
    CORBA::ORB_var orb_;

    //
    // Members needed for the TestIntf tests
    //
    CORBA::Short aShort;
    CORBA::UShort aUShort;
    CORBA::Long aLong;
    CORBA::ULong aULong;
    CORBA::Float aFloat;
    CORBA::Double aDouble;
    CORBA::Boolean aBoolean;
    CORBA::Char aChar;
    CORBA::Octet aOctet;
    CORBA::String_var aString;
    CORBA::Any aAny;
    TestIntf::TestEnum aTestEnum;
    TestIntf_var aTestIntf;
    TestIntf::FixedStruct aFixedStruct;
    TestIntf::VariableStruct aVariableStruct;
    TestIntf::FixedUnion aFixedUnion;
    TestIntf::VariableUnion aVariableUnion;
    TestIntf::StringSequence aStringSequence;
    TestIntf::FixedArray aFixedArray;
    TestIntf::VariableArray aVariableArray;
    TestIntf::FixedArraySequence aFixedArraySequence;
    TestIntf::VariableArraySequence aVariableArraySequence;
    TestIntf::FixedArrayBoundSequence aFixedArrayBoundSequence;
    TestIntf::VariableArrayBoundSequence aVariableArrayBoundSequence;

    //
    // Members needed for the TestIntf_2_3_NoLongDouble tests
    //
    CORBA::LongLong aLongLong;
    CORBA::ULongLong aULongLong;

    //
    // Members needed for the TestIntf_2_3 tests
    //
    CORBA::LongDouble aLongDouble;

public:

    TestIntf_2_3_impl(CORBA::ORB_ptr);

    // ----------------------------------------------------------------------
    // Methods from TestIntf
    // ----------------------------------------------------------------------

    virtual void deactivate()
        throw(CORBA::SystemException);

    virtual CORBA::ULong version()
        throw(CORBA::SystemException);

    virtual void sleepOneway(CORBA::ULong sec)
        throw(CORBA::SystemException);

    virtual void sleepTwoway(CORBA::ULong sec)
        throw(CORBA::SystemException);

    virtual void opVoid()
        throw(CORBA::SystemException);

    virtual void opVoidEx()
        throw(TestIntf::ExVoid,
              CORBA::SystemException);

    virtual CORBA::Short attrShort()
        throw(CORBA::SystemException);
    virtual void attrShort(CORBA::Short)
        throw(CORBA::SystemException);

    virtual CORBA::Short opShort(CORBA::Short,
                                 CORBA::Short&,
                                 CORBA::Short_out)
        throw(CORBA::SystemException);

    virtual CORBA::Short opShortEx(CORBA::Short,
                                   CORBA::Short&,
                                   CORBA::Short_out)
        throw(TestIntf::ExShort,
              CORBA::SystemException);

    virtual CORBA::Long attrLong()
        throw(CORBA::SystemException);
    virtual void attrLong(CORBA::Long)
        throw(CORBA::SystemException);

    virtual CORBA::Long opLong(CORBA::Long,
                               CORBA::Long&,
                               CORBA::Long_out)
        throw(CORBA::SystemException);

    virtual CORBA::Long opLongEx(CORBA::Long,
                                 CORBA::Long&,
                                 CORBA::Long_out)
        throw(TestIntf::ExLong,
              CORBA::SystemException);

    virtual CORBA::UShort attrUShort()
        throw(CORBA::SystemException);
    virtual void attrUShort(CORBA::UShort)
        throw(CORBA::SystemException);

    virtual CORBA::UShort opUShort(CORBA::UShort,
                                   CORBA::UShort&,
                                   CORBA::UShort_out)
        throw(CORBA::SystemException);

    virtual CORBA::UShort opUShortEx(CORBA::UShort,
                                     CORBA::UShort&,
                                     CORBA::UShort_out)
        throw(TestIntf::ExUShort,
              CORBA::SystemException);

    virtual CORBA::ULong attrULong()
        throw(CORBA::SystemException);
    virtual void attrULong(CORBA::ULong)
        throw(CORBA::SystemException);

    virtual CORBA::ULong opULong(CORBA::ULong,
                                 CORBA::ULong&,
                                 CORBA::ULong_out)
        throw(CORBA::SystemException);

    virtual CORBA::ULong opULongEx(CORBA::ULong,
                                   CORBA::ULong&,
                                   CORBA::ULong_out)
        throw(TestIntf::ExULong,
              CORBA::SystemException);

    virtual CORBA::Float attrFloat()
        throw(CORBA::SystemException);
    virtual void attrFloat(CORBA::Float)
        throw(CORBA::SystemException);

    virtual CORBA::Float opFloat(CORBA::Float,
                                 CORBA::Float&,
                                 CORBA::Float_out)
        throw(CORBA::SystemException);

    virtual CORBA::Float opFloatEx(CORBA::Float,
                                   CORBA::Float&,
                                   CORBA::Float_out)
        throw(TestIntf::ExFloat,
              CORBA::SystemException);

    virtual CORBA::Double attrDouble()
        throw(CORBA::SystemException);
    virtual void attrDouble(CORBA::Double)
        throw(CORBA::SystemException);

    virtual CORBA::Double opDouble(CORBA::Double,
                                   CORBA::Double&,
                                   CORBA::Double_out)
        throw(CORBA::SystemException);

    virtual CORBA::Double opDoubleEx(CORBA::Double,
                                     CORBA::Double&,
                                     CORBA::Double_out)
        throw(TestIntf::ExDouble,
              CORBA::SystemException);

    virtual CORBA::Boolean attrBoolean()
        throw(CORBA::SystemException);
    virtual void attrBoolean(CORBA::Boolean)
        throw(CORBA::SystemException);

    virtual CORBA::Boolean opBoolean(CORBA::Boolean,
                                     CORBA::Boolean&,
                                     CORBA::Boolean_out)
        throw(CORBA::SystemException);

    virtual CORBA::Boolean opBooleanEx(CORBA::Boolean,
                                       CORBA::Boolean&,
                                       CORBA::Boolean_out)
        throw(TestIntf::ExBoolean,
              CORBA::SystemException);

    virtual CORBA::Char attrChar()
        throw(CORBA::SystemException);
    virtual void attrChar(CORBA::Char)
        throw(CORBA::SystemException);

    virtual CORBA::Char opChar(CORBA::Char,
                               CORBA::Char&,
                               CORBA::Char_out)
        throw(CORBA::SystemException);

    virtual CORBA::Char opCharEx(CORBA::Char,
                                 CORBA::Char&,
                                 CORBA::Char_out)
        throw(TestIntf::ExChar,
              CORBA::SystemException);

    virtual CORBA::Octet attrOctet()
        throw(CORBA::SystemException);
    virtual void attrOctet(CORBA::Octet)
        throw(CORBA::SystemException);

    virtual CORBA::Octet opOctet(CORBA::Octet,
                                 CORBA::Octet&,
                                 CORBA::Octet_out)
        throw(CORBA::SystemException);

    virtual CORBA::Octet opOctetEx(CORBA::Octet,
                                   CORBA::Octet&,
                                   CORBA::Octet_out)
        throw(TestIntf::ExOctet,
              CORBA::SystemException);

    virtual char* attrString()
        throw(CORBA::SystemException);
    virtual void attrString(const char*)
        throw(CORBA::SystemException);

    virtual char* opString(const char*,
                           char*&,
                           CORBA::String_out)
        throw(CORBA::SystemException);

    virtual char* opStringEx(const char*,
                             char*&,
                             CORBA::String_out)
        throw(TestIntf::ExString,
              CORBA::SystemException);

    virtual CORBA::Any* attrAny()
        throw(CORBA::SystemException);
    virtual void attrAny(const CORBA::Any&)
        throw(CORBA::SystemException);

    virtual CORBA::Any* opAny(const CORBA::Any&,
                              CORBA::Any&,
                              CORBA::Any_out)
        throw(CORBA::SystemException);

    virtual CORBA::Any* opAnyEx(const CORBA::Any&,
                                CORBA::Any&,
                                CORBA::Any_out)
        throw(TestIntf::ExAny,
              CORBA::SystemException);

    virtual TestIntf::TestEnum attrTestEnum()
        throw(CORBA::SystemException);
    virtual void attrTestEnum(TestIntf::TestEnum)
        throw(CORBA::SystemException);

    virtual TestIntf::TestEnum opTestEnum(TestIntf::TestEnum,
                                          TestIntf::TestEnum&,
                                          TestIntf::TestEnum_out)
        throw(CORBA::SystemException);

    virtual TestIntf::TestEnum opTestEnumEx(TestIntf::TestEnum,
                                            TestIntf::TestEnum&,
                                            TestIntf::TestEnum_out)
        throw(TestIntf::ExTestEnum,
              CORBA::SystemException);

    virtual TestIntf_ptr attrTestIntf()
        throw(CORBA::SystemException);
    virtual void attrTestIntf(TestIntf_ptr)
        throw(CORBA::SystemException);

    virtual TestIntf_ptr opTestIntf(TestIntf_ptr,
                                    TestIntf_ptr&,
                                    TestIntf_out)
        throw(CORBA::SystemException);

    virtual TestIntf_ptr opTestIntfEx(TestIntf_ptr,
                                      TestIntf_ptr&,
                                      TestIntf_out)
        throw(TestIntf::ExTestIntf,
              CORBA::SystemException);

    virtual TestIntf::FixedStruct attrFixedStruct()
        throw(CORBA::SystemException);
    virtual void attrFixedStruct(const TestIntf::FixedStruct&)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedStruct opFixedStruct(const TestIntf::FixedStruct&,
                                                TestIntf::FixedStruct&,
                                                TestIntf::FixedStruct_out)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedStruct opFixedStructEx(const TestIntf::FixedStruct&,
                                                  TestIntf::FixedStruct&,
                                                  TestIntf::FixedStruct_out)
        throw(TestIntf::ExFixedStruct,
              CORBA::SystemException);

    virtual TestIntf::VariableStruct* attrVariableStruct()
        throw(CORBA::SystemException);
    virtual void attrVariableStruct(const TestIntf::VariableStruct&)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableStruct*
    opVariableStruct(const TestIntf::VariableStruct&,
		     TestIntf::VariableStruct&,
		     TestIntf::VariableStruct_out)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableStruct*
    opVariableStructEx(const TestIntf::VariableStruct&,
		       TestIntf::VariableStruct&,
		       TestIntf::VariableStruct_out)
        throw(TestIntf::ExVariableStruct,
              CORBA::SystemException);

    virtual TestIntf::FixedUnion attrFixedUnion()
        throw(CORBA::SystemException);
    virtual void attrFixedUnion(const TestIntf::FixedUnion&)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedUnion opFixedUnion(const TestIntf::FixedUnion&,
                                              TestIntf::FixedUnion&,
                                              TestIntf::FixedUnion_out)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedUnion opFixedUnionEx(const TestIntf::FixedUnion&,
                                                TestIntf::FixedUnion&,
                                                TestIntf::FixedUnion_out)
        throw(TestIntf::ExFixedUnion,
              CORBA::SystemException);

    virtual TestIntf::VariableUnion* attrVariableUnion()
        throw(CORBA::SystemException);
    virtual void attrVariableUnion(const TestIntf::VariableUnion&)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableUnion*
    opVariableUnion(const TestIntf::VariableUnion&,
		    TestIntf::VariableUnion&,
		    TestIntf::VariableUnion_out)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableUnion*
    opVariableUnionEx(const TestIntf::VariableUnion&,
		      TestIntf::VariableUnion&,
		      TestIntf::VariableUnion_out)
        throw(TestIntf::ExVariableUnion,
              CORBA::SystemException);

    virtual TestIntf::StringSequence* attrStringSequence()
        throw(CORBA::SystemException);
    virtual void attrStringSequence(const TestIntf::StringSequence&)
        throw(CORBA::SystemException);

    virtual TestIntf::StringSequence*
    opStringSequence(const TestIntf::StringSequence&,
		     TestIntf::StringSequence&,
		     TestIntf::StringSequence_out)
        throw(CORBA::SystemException);

    virtual TestIntf::StringSequence*
    opStringSequenceEx(const TestIntf::StringSequence&,
		       TestIntf::StringSequence&,
		       TestIntf::StringSequence_out)
        throw(TestIntf::ExStringSequence,
              CORBA::SystemException);

    virtual TestIntf::FixedArray_slice* attrFixedArray()
        throw(CORBA::SystemException);
    virtual void attrFixedArray(const TestIntf::FixedArray)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedArray_slice*
    opFixedArray(const TestIntf::FixedArray,
		 TestIntf::FixedArray,
		 TestIntf::FixedArray_out)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedArray_slice*
    opFixedArrayEx(const TestIntf::FixedArray,
		   TestIntf::FixedArray,
		   TestIntf::FixedArray_out)
        throw(TestIntf::ExFixedArray,
              CORBA::SystemException);

    virtual TestIntf::VariableArray_slice* attrVariableArray()
        throw(CORBA::SystemException);
    virtual void attrVariableArray(const TestIntf::VariableArray)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableArray_slice*
    opVariableArray(const TestIntf::VariableArray,
		    TestIntf::VariableArray,
		    TestIntf::VariableArray_out)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableArray_slice*
    opVariableArrayEx(const TestIntf::VariableArray,
		      TestIntf::VariableArray,
		      TestIntf::VariableArray_out)
        throw(TestIntf::ExVariableArray,
              CORBA::SystemException);

    virtual TestIntf::FixedArraySequence* attrFixedArraySequence()
        throw(CORBA::SystemException);
    virtual void attrFixedArraySequence(const TestIntf::FixedArraySequence&)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedArraySequence*
    opFixedArraySequence(const TestIntf::FixedArraySequence&,
			 TestIntf::FixedArraySequence&,
			 TestIntf::FixedArraySequence_out)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedArraySequence*
    opFixedArraySequenceEx(const TestIntf::FixedArraySequence&,
			   TestIntf::FixedArraySequence&,
			   TestIntf::FixedArraySequence_out)
        throw(TestIntf::ExFixedArraySequence,
              CORBA::SystemException);

    virtual TestIntf::VariableArraySequence* attrVariableArraySequence()
        throw(CORBA::SystemException);
    virtual void
    attrVariableArraySequence(const TestIntf::VariableArraySequence&)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableArraySequence*
    opVariableArraySequence(const TestIntf::VariableArraySequence&,
			    TestIntf::VariableArraySequence&,
			    TestIntf::VariableArraySequence_out)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableArraySequence*
    opVariableArraySequenceEx(const TestIntf::VariableArraySequence&,
			      TestIntf::VariableArraySequence&,
			      TestIntf::VariableArraySequence_out)
        throw(TestIntf::ExVariableArraySequence,
              CORBA::SystemException);

    virtual TestIntf::FixedArrayBoundSequence* attrFixedArrayBoundSequence()
        throw(CORBA::SystemException);
    virtual void
    attrFixedArrayBoundSequence(const TestIntf::FixedArrayBoundSequence&)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedArrayBoundSequence*
    opFixedArrayBoundSequence(const TestIntf::FixedArrayBoundSequence&,
			 TestIntf::FixedArrayBoundSequence&,
			 TestIntf::FixedArrayBoundSequence_out)
        throw(CORBA::SystemException);

    virtual TestIntf::FixedArrayBoundSequence*
    opFixedArrayBoundSequenceEx(const TestIntf::FixedArrayBoundSequence&,
			   TestIntf::FixedArrayBoundSequence&,
			   TestIntf::FixedArrayBoundSequence_out)
        throw(TestIntf::ExFixedArrayBoundSequence,
              CORBA::SystemException);

    virtual TestIntf::VariableArrayBoundSequence*
    attrVariableArrayBoundSequence()
        throw(CORBA::SystemException);
    virtual void
    attrVariableArrayBoundSequence(const TestIntf::VariableArrayBoundSequence&)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableArrayBoundSequence*
    opVariableArrayBoundSequence(const TestIntf::VariableArrayBoundSequence&,
			    TestIntf::VariableArrayBoundSequence&,
			    TestIntf::VariableArrayBoundSequence_out)
        throw(CORBA::SystemException);

    virtual TestIntf::VariableArrayBoundSequence*
    opVariableArrayBoundSequenceEx(const TestIntf::VariableArrayBoundSequence&,
			      TestIntf::VariableArrayBoundSequence&,
			      TestIntf::VariableArrayBoundSequence_out)
        throw(TestIntf::ExVariableArrayBoundSequence,
              CORBA::SystemException);

    virtual void op_UNKNOWN_Ex()
        throw(CORBA::SystemException);

    virtual void op_BAD_PARAM_Ex()
        throw(CORBA::SystemException);

    virtual void op_NO_MEMORY_Ex()
        throw(CORBA::SystemException);

    virtual void op_IMP_LIMIT_Ex()
        throw(CORBA::SystemException);

    virtual void op_COMM_FAILURE_Ex()
        throw(CORBA::SystemException);

    virtual void op_INV_OBJREF_Ex()
        throw(CORBA::SystemException);

    virtual void op_NO_PERMISSION_Ex()
        throw(CORBA::SystemException);

    virtual void op_INTERNAL_Ex()
        throw(CORBA::SystemException);

    virtual void op_MARSHAL_Ex()
        throw(CORBA::SystemException);

    virtual void op_INITIALIZE_Ex()
        throw(CORBA::SystemException);

    virtual void op_NO_IMPLEMENT_Ex()
        throw(CORBA::SystemException);

    virtual void op_BAD_TYPECODE_Ex()
        throw(CORBA::SystemException);

    virtual void op_BAD_OPERATION_Ex()
        throw(CORBA::SystemException);

    virtual void op_NO_RESOURCES_Ex()
        throw(CORBA::SystemException);

    virtual void op_NO_RESPONSE_Ex()
        throw(CORBA::SystemException);

    virtual void op_BAD_INV_ORDER_Ex()
        throw(CORBA::SystemException);

    virtual void op_TRANSIENT_Ex()
        throw(CORBA::SystemException);

    virtual void op_OBJ_ADAPTER_Ex()
        throw(CORBA::SystemException);

    virtual void op_OBJECT_NOT_EXIST_Ex()
        throw(CORBA::SystemException);

    virtual void op_INV_POLICY_Ex()
        throw(CORBA::SystemException);

    // ----------------------------------------------------------------------
    // Methods from TestIntf_2_3_NoLongDouble
    // ----------------------------------------------------------------------

    virtual CORBA::LongLong attrLongLong()
        throw(CORBA::SystemException);
    virtual void attrLongLong(CORBA::LongLong)
        throw(CORBA::SystemException);

    virtual CORBA::LongLong opLongLong(CORBA::LongLong,
                                       CORBA::LongLong&,
                                       CORBA::LongLong_out)
        throw(CORBA::SystemException);

    virtual CORBA::LongLong opLongLongEx(CORBA::LongLong,
                                         CORBA::LongLong&,
                                         CORBA::LongLong_out)
        throw(TestIntf_2_3_NoLongDouble::ExLongLong,
              CORBA::SystemException);

    virtual CORBA::ULongLong attrULongLong()
        throw(CORBA::SystemException);
    virtual void attrULongLong(CORBA::ULongLong)
        throw(CORBA::SystemException);

    virtual CORBA::ULongLong opULongLong(CORBA::ULongLong,
                                         CORBA::ULongLong&,
                                         CORBA::ULongLong_out)
        throw(CORBA::SystemException);

    virtual CORBA::ULongLong opULongLongEx(CORBA::ULongLong,
                                           CORBA::ULongLong&,
                                           CORBA::ULongLong_out)
        throw(TestIntf_2_3_NoLongDouble::ExULongLong,
              CORBA::SystemException);

    // ----------------------------------------------------------------------
    // Methods from TestIntf_2_3
    // ----------------------------------------------------------------------

    virtual CORBA::LongDouble attrLongDouble()
        throw(CORBA::SystemException);
    virtual void attrLongDouble(CORBA::LongDouble)
        throw(CORBA::SystemException);

    virtual CORBA::LongDouble opLongDouble(CORBA::LongDouble,
                                           CORBA::LongDouble&,
                                           CORBA::LongDouble_out)
        throw(CORBA::SystemException);

    virtual CORBA::LongDouble opLongDoubleEx(CORBA::LongDouble,
                                             CORBA::LongDouble&,
                                             CORBA::LongDouble_out)
        throw(TestIntf_2_3::ExLongDouble,
              CORBA::SystemException);
};

#endif
