# **********************************************************************
#
# Copyright (c) 1999
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

TARGETS		= TestMisc.exe \
		  TestRefCount.exe \
		  TestClient.exe \
		  TestRefCountServer.exe \
		  TestMultipleOrbsThreadedServer.exe \
		  TestMultipleOrbsThreadedClient.exe

PDB_FILES      =  $(TARGETS:.exe=.pdb)

!include $(top_srcdir)\config\Make.rules.mak

COMMON_OBJS	= Test.obj

SERVER_OBJS	= Test_skel.obj \
		  Test_impl.obj \
		  TestServer_impl.obj \
		  TestRef_impl.obj \
		  TestUtil.obj

SRCS		= $(COMMON_OBJS:.obj=.cpp) \
		  $(SERVER_OBJS:.obj=.cpp) \
		  TestMisc.cpp \
		  TestRefCount.cpp \
		  TestClient.cpp \
		  TestRefCountServer.cpp \
		  TestMultipleOrbsThreadedServer.cpp \
		  TestMultipleOrbsThreadedClient.cpp

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)
ALL_CPPFLAGS	= /I. /I..\include $(OBE_CPPFLAGS) $(CPPFLAGS) 
SERVER_LIBS	= $(OBE_SERVER_LIBS) $(LIBS)
CLIENT_LIBS	= $(OBE_CLIENT_LIBS) $(LIBS)

TestMisc.exe: TestMisc.obj $(COMMON_OBJS) $(SERVER_OBJS)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) \
	$(COMMON_OBJS) $(SERVER_OBJS) $(SERVER_LIBS)

TestRefCount.exe: TestRefCount.obj $(COMMON_OBJS) $(SERVER_OBJS)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) \
	$(COMMON_OBJS) $(SERVER_OBJS) $(SERVER_LIBS)

TestClient.exe: TestClient.obj $(COMMON_OBJS)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) \
	$(COMMON_OBJS) $(CLIENT_LIBS)

TestRefCountServer.exe: TestRefCountServer.obj $(COMMON_OBJS) $(SERVER_OBJS)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) \
	$(COMMON_OBJS) $(SERVER_OBJS) $(SERVER_LIBS)

TestMultipleOrbsThreadedServer.exe: TestMultipleOrbsThreadedServer.obj \
	$(COMMON_OBJS) $(SERVER_OBJS) 
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) \
	$(COMMON_OBJS) $(SERVER_OBJS) $(SERVER_LIBS)

TestMultipleOrbsThreadedClient.exe: TestMultipleOrbsThreadedClient.obj \
	$(COMMON_OBJS)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) \
	$(COMMON_OBJS) $(CLIENT_LIBS)

Test.cpp Test.h: Test.idl
	-del Test.cpp Test.h
	-del Test_skel.cpp Test_skel.h
	$(IDL) --no-type-codes Test.idl

Test_skel.cpp Test_skel.h : Test.cpp

!include .windep
