// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OBE/CORBA.h>

#include <TestMacro.h>
#include <Types.h>

using namespace CORBA;

void
TestTypeCode()
{
    {
	TCKind kind = _tc_completion_status -> kind();
	TEST(kind == tk_enum);

	String_var name = _tc_completion_status -> name();
	TEST(strcmp(name, "completion_status") == 0);

	String_var id = _tc_completion_status -> id();
	TEST(strcmp(id, "IDL:omg.org/CORBA/completion_status:1.0") == 0);

#ifndef NDEBUG
	ULong count = _tc_completion_status -> _OB_memberCount();
	TEST(count == 3);

	String_var name0 = _tc_completion_status -> _OB_memberName(0);
	TEST(strcmp(name0, "COMPLETED_YES") == 0);

	String_var name1 = _tc_completion_status -> _OB_memberName(1);
	TEST(strcmp(name1, "COMPLETED_NO") == 0);

	String_var name2 = _tc_completion_status -> _OB_memberName(2);
	TEST(strcmp(name2, "COMPLETED_MAYBE") == 0);
#endif
    }

    {
	TCKind kind = TypeCode::_tc_BadKind -> kind();
	TEST(kind == tk_except);

	String_var name = TypeCode::_tc_BadKind -> name();
	TEST(strcmp(name, "BadKind") == 0);

	String_var id = TypeCode::_tc_BadKind -> id();
	TEST(strcmp(id, "IDL:omg.org/CORBA/TypeCode/BadKind:1.0") == 0);

#ifndef NDEBUG
	ULong count = TypeCode::_tc_BadKind -> _OB_memberCount();
	TEST(count == 0);
#endif
    }

    {
	TCKind kind = _tc_TestStruct1 -> kind();
	TEST(kind == tk_struct);

	String_var name = _tc_TestStruct1 -> name();
	TEST(strcmp(name, "TestStruct1") == 0);

#ifndef NDEBUG
	ULong count = _tc_TestStruct1 -> _OB_memberCount();
	TEST(count == 7);

	String_var name0 = _tc_TestStruct1 -> _OB_memberName(0);
	TEST(strcmp(name0, "s") == 0);

	String_var name1 = _tc_TestStruct1 -> _OB_memberName(1);
	TEST(strcmp(name1, "l") == 0);

	String_var name2 = _tc_TestStruct1 -> _OB_memberName(2);
	TEST(strcmp(name2, "d") == 0);

	String_var name3 = _tc_TestStruct1 -> _OB_memberName(3);
	TEST(strcmp(name3, "b") == 0);

	String_var name4 = _tc_TestStruct1 -> _OB_memberName(4);
	TEST(strcmp(name4, "c") == 0);

	String_var name5 = _tc_TestStruct1 -> _OB_memberName(5);
	TEST(strcmp(name5, "o") == 0);

	String_var name6 = _tc_TestStruct1 -> _OB_memberName(6);
	TEST(strcmp(name6, "str") == 0);

	TypeCode_ptr type0 = _tc_TestStruct1 -> _OB_memberType_nodup(0);
	TEST(type0 -> equal(_tc_short));

	TypeCode_ptr type1 = _tc_TestStruct1 -> _OB_memberType_nodup(1);
	TEST(type1 -> equal(_tc_long));

	TypeCode_ptr type2 = _tc_TestStruct1 -> _OB_memberType_nodup(2);
	TEST(type2 -> equal(_tc_double));

	TypeCode_ptr type3 = _tc_TestStruct1 -> _OB_memberType_nodup(3);
	TEST(type3 -> equal(_tc_boolean));

	TypeCode_ptr type4 = _tc_TestStruct1 -> _OB_memberType_nodup(4);
	TEST(type4 -> equal(_tc_char));

	TypeCode_ptr type5 = _tc_TestStruct1 -> _OB_memberType_nodup(5);
	TEST(type5 -> equal(_tc_octet));

	TypeCode_ptr type6 = _tc_TestStruct1 -> _OB_memberType_nodup(6);
	TEST(type6 -> equal(_tc_string));
#endif
    }

    {
	TCKind kind = _tc_TestStruct2 -> kind();
	TEST(kind == tk_struct);

	String_var name = _tc_TestStruct2 -> name();
	TEST(strcmp(name, "TestStruct2") == 0);

#ifndef NDEBUG
	ULong count = _tc_TestStruct2 -> _OB_memberCount();
	TEST(count == 4);

	String_var name0 = _tc_TestStruct2 -> _OB_memberName(0);
	TEST(strcmp(name0, "s") == 0);

	TypeCode_ptr type0 = _tc_TestStruct2 -> _OB_memberType_nodup(0);
	TEST(type0 -> equal(_tc_TestStruct1));

	String_var name1 = _tc_TestStruct2 -> _OB_memberName(1);
	TEST(strcmp(name1, "a") == 0);

	TypeCode_ptr type1 = _tc_TestStruct2 -> _OB_memberType_nodup(1);
	TEST(type1 -> equal(_tc_any));

	String_var name2 = _tc_TestStruct2 -> _OB_memberName(2);
	TEST(strcmp(name2, "da") == 0);

	TypeCode_ptr type2 = _tc_TestStruct2 -> _OB_memberType_nodup(2);
	TEST(type2 -> equal(_tc_DoubleArray));

	String_var name3 = _tc_TestStruct2 -> _OB_memberName(3);
	TEST(strcmp(name3, "sa") == 0);

	TypeCode_ptr type3 = _tc_TestStruct2 -> _OB_memberType_nodup(3);
	//TEST(type3 -> equal(_tc_...));
#endif
    }

    {
	TCKind kind = _tc_TestStruct3 -> kind();
	TEST(kind == tk_struct);

	String_var name = _tc_TestStruct3 -> name();
	TEST(strcmp(name, "TestStruct3") == 0);

#ifndef NDEBUG
	ULong count = _tc_TestStruct3 -> _OB_memberCount();
	TEST(count == 2);

	String_var name0 = _tc_TestStruct3 -> _OB_memberName(0);
	TEST(strcmp(name0, "l") == 0);

	TypeCode_ptr type0 = _tc_TestStruct3 -> _OB_memberType_nodup(0);
	TEST(type0 -> equal(_tc_long));

	String_var name1 = _tc_TestStruct3 -> _OB_memberName(1);
	TEST(strcmp(name1, "seq") == 0);

	TypeCode_ptr type1 = _tc_TestStruct3 -> _OB_memberType_nodup(1);
	TypeCode_ptr contentType = type1 -> _OB_contentType_nodup();
	TEST(contentType -> equal(_tc_TestStruct3));
#endif
    }

    {
	TCKind kind = _tc_TestStruct4 -> kind();
	TEST(kind == tk_struct);

	String_var name = _tc_TestStruct4 -> name();
	TEST(strcmp(name, "TestStruct4") == 0);

#ifndef NDEBUG
	ULong count = _tc_TestStruct4 -> _OB_memberCount();
	TEST(count == 2);

	String_var name0 = _tc_TestStruct4 -> _OB_memberName(0);
	TEST(strcmp(name0, "a") == 0);

	TypeCode_ptr type0 = _tc_TestStruct4 -> _OB_memberType_nodup(0);
	TEST(type0 -> equal(_tc_TestStruct3));

	String_var name1 = _tc_TestStruct4 -> _OB_memberName(1);
	TEST(strcmp(name1, "b") == 0);

	TypeCode_ptr type1 = _tc_TestStruct4 -> _OB_memberType_nodup(1);
	TypeCode_ptr contentType = type1 -> _OB_contentType_nodup();
	TEST(contentType -> equal(_tc_TestStruct3));
#endif
    }

    {
	TCKind kind = _tc_TestUnion4 -> kind();
	TEST(kind == tk_union);

	String_var name = _tc_TestUnion4 -> name();
	TEST(strcmp(name, "TestUnion4") == 0);

#ifndef NDEBUG
	ULong count = _tc_TestUnion4 -> _OB_memberCount();
	TEST(count == 2);

	String_var name0 = _tc_TestUnion4 -> _OB_memberName(0);
	TEST(strcmp(name0, "seq") == 0);

	TypeCode_ptr type0 = _tc_TestUnion4 -> _OB_memberType_nodup(0);
	TypeCode_ptr contentType = type0 -> _OB_contentType_nodup();
	TEST(contentType -> equal(_tc_TestUnion4));

	String_var name1 = _tc_TestUnion4 -> _OB_memberName(1);
	TEST(strcmp(name1, "c") == 0);

	TypeCode_ptr type1 = _tc_TestUnion4 -> _OB_memberType_nodup(1);
	TEST(type1 -> equal(_tc_char));
#endif
    }
    {
	TypeCode_ptr p;

	p = _tc_RepositoryId;
	TEST(strcmp(p -> name(), "RepositoryId") == 0);
    }
}
