// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OBE/CORBA.h>

using namespace CORBA;

int
run(ORB_ptr orb, int argc, char* argv[])
{
    try
    {
        printf("Testing constants... ");
	fflush(stdout);
        extern void TestConst();
        TestConst();
        printf("OK!\n");

        printf("Testing TypeCode type... ");
	fflush(stdout);
        extern void TestTypeCode();
        TestTypeCode();
        printf("OK!\n");
        
        printf("Testing any type... ");
	fflush(stdout);
        extern void TestAny();
        TestAny();
        printf("OK!\n");

        printf("Testing some union types... ");
	fflush(stdout);
        extern void TestUnion();
        TestUnion();
        printf("OK!\n");

	printf("Testing sequence types...");
	fflush(stdout);
	extern void TestSequence();
	TestSequence();
	printf("OK!\n");
    }
    catch(const Exception& ex)
    {
	fprintf(stderr, "%s\n", ex._rep_id());
        return 1;
    }

    return 0;
}

int
main(int argc, char* argv[])
{
    int status = EXIT_SUCCESS;
    ORB_var orb;

    try
    {
        //
        // Create ORB
        //
        orb = ORB_init(argc, argv);

	//
	// Run the test
	//
	status = run(orb, argc, argv);
    }
    catch(const Exception& ex)
    {
	fprintf(stderr, "%s\n", ex._rep_id());
        status = EXIT_SUCCESS;
    }

    if(!is_nil(orb))
    {
	try
	{
	    orb -> destroy();
	}
	catch(const Exception& ex)
	{
	    fprintf(stderr, "%s\n", ex._rep_id());
	    status = EXIT_FAILURE;
	}
    }

    return status;
}
